// BridgeCollection.cpp: implementation of the BridgeCollection class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Map Studio MAX R1.h"
#include "BridgeCollection.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////
IMPLEMENT_SERIAL (BridgeCollection, CObject, 1)

BridgeCollection::BridgeCollection()
{

}

BridgeCollection::~BridgeCollection()
{

}


CBridge* BridgeCollection::AddBridge (CPoint ptFrom, CPoint ptTo, UINT nWidth, UINT lines_distance, COLORREF crColor)
{
    CBridge* pBridge;
    try 
	{
        pBridge = new CBridge (ptFrom, ptTo, nWidth, lines_distance, crColor);
        m_bridgeArray.Add (pBridge);
        //SetModifiedFlag();
    }
    catch (CMemoryException* error)
	{
        if (pBridge != NULL) 
		{
			delete pBridge;
            pBridge = NULL;
        }
        AfxMessageBox ("Out of memory", MB_ICONSTOP | MB_OK);
        error->Delete ();
    }
    return pBridge;
}

void BridgeCollection::DeleteBridge (int index)
{
	m_bridgeArray.RemoveAt(index);
}

void BridgeCollection::DeleteBridgeContents ()
{
    int bridge_size = m_bridgeArray.GetSize ();

    if (bridge_size) 
	{
        for (int i=0; i<bridge_size; i++)
            delete m_bridgeArray[i];
        m_bridgeArray.RemoveAll ();
    }
}


CBridge* BridgeCollection::GetBridge (int nIndex)
{
    return (CBridge*) m_bridgeArray[nIndex];
}


int BridgeCollection::GetBridgeCount ()
{
    return m_bridgeArray.GetSize ();
}


void BridgeCollection::Serialize (CArchive& ar)
{
    CObject::Serialize (ar);
	m_bridgeArray.Serialize (ar);
}


CObArray* BridgeCollection::GetBridgeCollection()
{
	return (CObArray*) &m_bridgeArray;
}

