// BridgeMode.cpp: implementation of the CBridgeMode class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Map Studio MAX R1.h"
#include "BridgeMode.h"
#include "BridgeView.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

IMPLEMENT_DYNAMIC(CBridgeMode, CMode)

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CBridgeMode::CBridgeMode(CMapDoc* doc)
:CMode(doc)
{
	index =0;
	hit = false;
}

CBridgeMode::~CBridgeMode()
{

}

CBridgeMode::OnLButtonDown(UINT nFlags, CPoint point, CDC* pDC)
{
	for (int n=0; ( (n<(_doc->bridge_collection->GetBridgeCount())) && !hit ); n++)
		if (_doc->bridge_collection->GetBridge(n)->HitTest(point))
		{
			CBridgeView temp_bridge_view;
			bridge_selected = _doc->bridge_collection->GetBridge(n);
			temp_bridge_view.SelectedBridge(pDC, bridge_selected->GetStartingPoint(),
											bridge_selected->GetEndPoint());
			index =n;
			hit = true;
		}
}

CBridgeMode::OnLButtonUp(UINT nFlags, CPoint point, CDC* pDC)
{
	CPoint m_ptFrom = GetView()->Getm_ptFrom();
	CBridge* pBridge = _doc->bridge_collection->AddBridge(m_ptFrom, point, 1, 18, RGB(218,254,44));
	if (pBridge != NULL) 
	{
		CBridgeView* temp_bridge_view = new CBridgeView(pBridge);						
		temp_bridge_view->Draw(pDC);
		_doc->UpdateAllViews(GetView(), 0, pBridge);
		_doc->widgets_sequence.Add("bridge");
		_doc->SetModifiedFlag(TRUE);
	}
}

CBridgeMode::OnMouseMove_Move(UINT nFlags, CPoint point, CDC* pDC)
{
	CSize diff; //amount moved
	diff.cx = point.x - bridge_selected->GetStartingPoint().x;
	diff.cy = point.y - bridge_selected->GetStartingPoint().y;

	bridge_selected->SetStartingPoint(CPoint(point.x, point.y));
	bridge_selected->SetEndPoint( CPoint(bridge_selected->GetEndPoint().x + diff.cx, 
								  bridge_selected->GetEndPoint().y + diff.cy));
}

CBridgeMode::OnMouseMove_Draw(UINT nFlags, CPoint point, CDC* pDC)
{
	CBridgeView temp_bridge_view;

	CPoint m_ptFrom = GetView()->Getm_ptFrom();
	CPoint m_ptTo = GetView()->Getm_ptTo();
	
	temp_bridge_view.InvertBridge(pDC, m_ptFrom, m_ptTo, 18);
	temp_bridge_view.InvertBridge(pDC, m_ptFrom, point, 18);
}

CBridgeMode::OnMouseMove_Resize(UINT nFlags, CPoint point, CDC* pDC)
{
	CSize diff; //amount moved
	diff.cx = point.x - bridge_selected->GetStartingPoint().x;
	diff.cy = point.y - bridge_selected->GetStartingPoint().y;

	bridge_selected->SetEndPoint( CPoint(point.x, point.y));
}

void CBridgeMode::delete_selected()
{
	_doc->bridge_collection->DeleteBridge(index);	
}

CBridgeMode::DoDialog()
{

}

bool CBridgeMode::IsHit()
{
	return hit;
}

CMapView* CBridgeMode::GetView() 
{
	POSITION pos = _doc->GetFirstViewPosition();
	return (CMapView*) _doc->GetNextView(pos);
}