// Circle.cpp: implementation of the CCircle class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Map Studio MAX R1.h"
#include "Circle.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

IMPLEMENT_SERIAL (CCircle, CObject, 1)

CCircle::CCircle (CPoint ptFrom, CPoint ptTo, UINT nWidth, COLORREF crColor)
{
    m_StartingPoint = ptFrom;
    m_EndPoint = ptTo;
    m_LineWidth = nWidth;
    m_LineColor = crColor;
}

void CCircle::Serialize (CArchive& ar)
{
    CObject::Serialize (ar);

    if (ar.IsStoring ())
        ar << m_StartingPoint << m_EndPoint << m_LineWidth << (DWORD) m_LineColor;
    else
        ar >> m_StartingPoint >> m_EndPoint >> m_LineWidth >> (DWORD) m_LineColor;
}

// Get methods
CPoint CCircle::GetStartingPoint()
{
	return m_StartingPoint;
}

CPoint CCircle::GetEndPoint()
{
	return m_EndPoint;
}

UINT CCircle::GetLineWidth()
{
	return m_LineWidth;
}

COLORREF CCircle::GetLineColor()
{
	return m_LineColor;
}

// Set methods
void CCircle::SetStartingPoint(CPoint start_point)
{
	m_StartingPoint = start_point;
}

void CCircle::SetEndPoint(CPoint end_point)
{
	m_EndPoint = end_point;
}

void CCircle::SetLineWidth(UINT line_width)
{
	m_LineWidth = line_width;
}

void CCircle::SetLineColor(COLORREF line_color)
{
	m_LineColor = line_color;
}

bool CCircle::HitTest(CPoint point)
{
    // check handles
    CRect R;

    R = CRect(m_StartingPoint, m_EndPoint );
    R.NormalizeRect();

    R.InflateRect( 5, 5 );
    
    if (R.PtInRect(point))
		return true;

	return false;
}

