// CircleMode.cpp: implementation of the CCircleMode class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Map Studio MAX R1.h"
#include "CircleMode.h"
#include "CircleView.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

IMPLEMENT_DYNAMIC(CCircleMode, CMode)

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CCircleMode::CCircleMode(CMapDoc* doc)
:CMode(doc)
{
	hit = false;
	index = 0;
}

CCircleMode::~CCircleMode()
{

}

CCircleMode::OnLButtonDown(UINT nFlags, CPoint point, CDC* pDC)
{
	for (int n=0; ( (n<(_doc->circle_collection->GetCircleCount())) && !hit); n++)
		if (_doc->circle_collection->GetCircle(n)->HitTest(point))
		{
			CCircleView temp_circle_view;
			circle_selected = _doc->circle_collection->GetCircle(n);
			temp_circle_view.SelectedCircle(pDC, circle_selected->GetStartingPoint(),
											circle_selected->GetEndPoint());
			index = n;
			hit = true;
		}
}

CCircleMode::OnLButtonUp(UINT nFlags, CPoint point, CDC* pDC)
{
	CPoint m_ptFrom = GetView()->Getm_ptFrom();
	CCircle* pCircle = _doc->circle_collection->AddCircle(m_ptFrom, point, 2, RGB(102,51,0));
	if (pCircle != NULL) 
	{
		CCircleView* temp_circle_view = new CCircleView(pCircle);						
		temp_circle_view->Draw(pDC);
		_doc->UpdateAllViews(GetView(), 0, pCircle);
		_doc->widgets_sequence.Add("circle");
		_doc->SetModifiedFlag(TRUE);
	}

}

CCircleMode::OnMouseMove_Move(UINT nFlags, CPoint point, CDC* pDC)
{
	CSize diff; //amount moved
			
	diff.cx = point.x - circle_selected->GetStartingPoint().x;
	diff.cy = point.y - circle_selected->GetStartingPoint().y;

	circle_selected->SetStartingPoint(CPoint(point.x, point.y));
	circle_selected->SetEndPoint( CPoint(circle_selected->GetEndPoint().x + diff.cx, 
								  circle_selected->GetEndPoint().y + diff.cy));
}

CCircleMode::OnMouseMove_Draw(UINT nFlags, CPoint point, CDC* pDC)
{
	CCircleView temp_circle_view;

	CPoint m_ptFrom = GetView()->Getm_ptFrom();
	CPoint m_ptTo = GetView()->Getm_ptTo();
	
	temp_circle_view.InvertCircle(pDC, m_ptFrom, m_ptTo);
	temp_circle_view.InvertCircle(pDC, m_ptFrom, point);
}

CCircleMode::OnMouseMove_Resize(UINT nFlags, CPoint point, CDC* pDC)
{
	CSize diff; //amount moved
			
	diff.cx = point.x - circle_selected->GetStartingPoint().x;
	diff.cy = point.y - circle_selected->GetStartingPoint().y;

	circle_selected->SetEndPoint( CPoint(point.x, point.y));
}

void CCircleMode::delete_selected()
{
	_doc->circle_collection->DeleteCircle(index);
}

CCircleMode::DoDialog()
{

}

bool CCircleMode::IsHit()
{
	return hit;
}

CMapView* CCircleMode::GetView() 
{
	POSITION pos = _doc->GetFirstViewPosition();
	return (CMapView*) _doc->GetNextView(pos);
}