// CircleView.cpp: implementation of the CCircleView class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Map Studio MAX R1.h"
#include "CircleView.h"


#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CCircleView::CCircleView()
{

}

CCircleView::CCircleView(CCircle* circle)
{
	m_StartingPoint = circle->GetStartingPoint();
    m_EndPoint = circle->GetEndPoint();
    m_LineWidth = circle->GetLineWidth();
    m_LineColor = circle->GetLineColor();
}

CCircleView::~CCircleView()
{

}

void CCircleView::Draw (CDC* pDC)
{
    CPen pen (PS_SOLID, m_LineWidth, m_LineColor);
    CBrush brush;
	brush.CreateSolidBrush(RGB(255, 255, 0));
	
	CPen* pOldPen = pDC->SelectObject (&pen);
	
	pDC->SelectObject (&brush);
	pDC->SelectObject (&pen);
    pDC->Ellipse(m_StartingPoint.x, m_StartingPoint.y, m_EndPoint.x, m_EndPoint.y);

	pDC->SelectObject (pOldPen);
}

void CCircleView::InvertCircle (CDC* pDC, CPoint ptFrom, CPoint ptTo)
{
    int nOldMode = pDC->SetROP2 (R2_NOTXORPEN);
    pDC->Ellipse(ptFrom.x, ptFrom.y, ptTo.x, ptTo.y);
    pDC->SetROP2(nOldMode);
}

void CCircleView::SelectedCircle (CDC* pDC, CPoint ptFrom, CPoint ptTo)
{
	CPoint ptFrom_upperLeft, ptFrom_lowerRight, ptTo_upperLeft, ptTo_lowerRight;
	
	ptFrom_upperLeft = CPoint(ptFrom.x-3, ptFrom.y-3);
	ptFrom_lowerRight = CPoint(ptFrom.x+3, ptFrom.y+3);
	ptTo_upperLeft = CPoint(ptTo.x-3, ptTo.y-3);
	ptTo_lowerRight = CPoint(ptTo.x+3, ptTo.y+3);

	CPen pen (PS_SOLID, 3, RGB(0,0,0));
    CPen* pOldPen = pDC->SelectObject (&pen);
	pDC->SelectObject (&pen);

	pDC->Rectangle(ptFrom_upperLeft.x, ptFrom_upperLeft.y, ptFrom_lowerRight.x, ptFrom_lowerRight.y);
	pDC->Rectangle(ptTo_upperLeft.x, ptTo_upperLeft.y, ptTo_lowerRight.x, ptTo_lowerRight.y);

	pDC->SelectObject (pOldPen);
}
