// HighWayCollection.cpp: implementation of the HighWayCollection class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "map studio max r1.h"
#include "HighWayCollection.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

IMPLEMENT_SERIAL (HighWayCollection, CObject, 1)

HighWayCollection::HighWayCollection()
{

}

HighWayCollection::~HighWayCollection()
{

}


CHighWay* HighWayCollection::AddHighWay (CPoint ptFrom, CPoint ptTo, UINT nWidth, UINT lines_distance, COLORREF crColor)
{
    CHighWay* pHighWay;
    try 
	{
        pHighWay = new CHighWay (ptFrom, ptTo, nWidth, lines_distance, crColor);
        m_highwayArray.Add (pHighWay);
        //SetModifiedFlag();
    }
    catch (CMemoryException* error)
	{
        if (pHighWay != NULL) 
		{
			delete pHighWay;
            pHighWay = NULL;
        }
        AfxMessageBox ("Out of memory", MB_ICONSTOP | MB_OK);
        error->Delete ();
    }
    return pHighWay;
}

void HighWayCollection::DeleteHighWay (int index)
{
	m_highwayArray.RemoveAt(index);
}

void HighWayCollection::DeleteHighWayContents ()
{
    int highway_size = m_highwayArray.GetSize ();

    if (highway_size) 
	{
        for (int i=0; i<highway_size; i++)
            delete m_highwayArray[i];
        m_highwayArray.RemoveAll ();
    }
}


CHighWay* HighWayCollection::GetHighWay (int nIndex)
{
    return (CHighWay*) m_highwayArray[nIndex];
}


int HighWayCollection::GetHighWayCount ()
{
    return m_highwayArray.GetSize ();
}


void HighWayCollection::Serialize (CArchive& ar)
{
    CObject::Serialize (ar);
	m_highwayArray.Serialize (ar);
}


CObArray* HighWayCollection::GetHighWayCollection()
{
	return (CObArray*) &m_highwayArray;
}

