// HighWayMode.cpp: implementation of the CHighWayMode class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "map studio max r1.h"
#include "HighWayMode.h"
#include "HighWayView.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif


IMPLEMENT_DYNAMIC(CHighWayMode, CMode)

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CHighWayMode::CHighWayMode(CMapDoc* doc)
:CMode(doc)
{
	hit = false;
	index =0;
}

CHighWayMode::~CHighWayMode()
{

}

CHighWayMode::OnLButtonDown(UINT nFlags, CPoint point, CDC* pDC)
{
	for (int n=0; ( (n<(_doc->highway_collection->GetHighWayCount())) && !hit); n++)
		if (_doc->highway_collection->GetHighWay(n)->HitTest(point))
		{
			CHighWayView temp_highway_view;
			highway_selected = _doc->highway_collection->GetHighWay(n);
			temp_highway_view.SelectedHighWay(pDC, highway_selected->GetStartingPoint(),
										highway_selected->GetEndPoint());
			index = n;
			hit = true;
		}
}

CHighWayMode::OnLButtonUp(UINT nFlags, CPoint point, CDC* pDC)
{
	CPoint m_ptFrom = GetView()->Getm_ptFrom();
	CHighWay* pHighWay = _doc->highway_collection->AddHighWay(m_ptFrom, point, 2, 15, RGB(51,255,153));
	if (pHighWay != NULL) 
	{
		CHighWayView* temp_highway_view = new CHighWayView(pHighWay);						
		temp_highway_view->Draw(pDC);
		_doc->UpdateAllViews(GetView(), 0, pHighWay);
		_doc->widgets_sequence.Add("highway");
		_doc->SetModifiedFlag(TRUE);
	}
}

CHighWayMode::OnMouseMove_Move(UINT nFlags, CPoint point, CDC* pDC)
{
	CSize diff; //amount moved
	
	diff.cx = point.x - highway_selected->GetStartingPoint().x;
	diff.cy = point.y - highway_selected->GetStartingPoint().y;

	highway_selected->SetStartingPoint(CPoint(point.x, point.y));
	highway_selected->SetEndPoint( CPoint(highway_selected->GetEndPoint().x + diff.cx, 
								highway_selected->GetEndPoint().y + diff.cy));
}

CHighWayMode::OnMouseMove_Draw(UINT nFlags, CPoint point, CDC* pDC)
{
	CHighWayView temp_highway_view;
	
	CPoint m_ptFrom = GetView()->Getm_ptFrom();
	CPoint m_ptTo = GetView()->Getm_ptTo();
	
	temp_highway_view.InvertHighWay(pDC, m_ptFrom, m_ptTo, 15);
	temp_highway_view.InvertHighWay(pDC, m_ptFrom, point, 15);
}

CHighWayMode::OnMouseMove_Resize(UINT nFlags, CPoint point, CDC* pDC)
{
	CSize diff; //amount moved
	
	diff.cx = point.x - highway_selected->GetStartingPoint().x;
	diff.cy = point.y - highway_selected->GetStartingPoint().y;

	highway_selected->SetEndPoint( CPoint(point.x, point.y));
}

void CHighWayMode::delete_selected()
{
	_doc->highway_collection->DeleteHighWay(index);
}

CHighWayMode::DoDialog()
{

}

bool CHighWayMode::IsHit()
{
	return hit;
}

CMapView* CHighWayMode::GetView() 
{
	POSITION pos = _doc->GetFirstViewPosition();
	return (CMapView*) _doc->GetNextView(pos);
}
