// Hospital.cpp: implementation of the CHospital class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "map studio max r1.h"
#include "Hospital.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif


//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////
IMPLEMENT_SERIAL (CHospital, CObject, 1)

CHospital::CHospital (CPoint ptFrom, CPoint ptTo, UINT nWidth, COLORREF crColor)
{
    m_StartingPoint = ptFrom;
    m_EndPoint = ptTo;
    m_LineWidth = nWidth;
    m_LineColor = crColor;
}

void CHospital::Serialize (CArchive& ar)
{
    CObject::Serialize (ar);

    if (ar.IsStoring ())
        ar << m_StartingPoint << m_EndPoint << m_LineWidth << (DWORD) m_LineColor;
    else
        ar >> m_StartingPoint >> m_EndPoint >> m_LineWidth >> (DWORD) m_LineColor;
}

// Get methods
CPoint CHospital::GetStartingPoint()
{
	return m_StartingPoint;
}

CPoint CHospital::GetEndPoint()
{
	return m_EndPoint;
}

UINT CHospital::GetLineWidth()
{
	return m_LineWidth;
}

COLORREF CHospital::GetLineColor()
{
	return m_LineColor;
}

// Set methods
void CHospital::SetStartingPoint(CPoint start_point)
{
	m_StartingPoint = start_point;
}

void CHospital::SetEndPoint(CPoint end_point)
{
	m_EndPoint = end_point;
}

void CHospital::SetLineWidth(UINT line_width)
{
	m_LineWidth = line_width;
}

void CHospital::SetLineColor(COLORREF line_color)
{
	m_LineColor = line_color;
}

bool CHospital::HitTest(CPoint point)
{
    // check handles
    CRect R;

    R = CRect(m_StartingPoint, m_EndPoint );
    R.NormalizeRect();

    R.InflateRect( 5, 5 );
    
    if (R.PtInRect(point))
		return true;

	return false;
}