// HospitalCollection.cpp: implementation of the HospitalCollection class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "map studio max r1.h"
#include "HospitalCollection.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

IMPLEMENT_SERIAL (HospitalCollection, CObject, 1)

HospitalCollection::HospitalCollection()
{

}

HospitalCollection::~HospitalCollection()
{

}


CHospital* HospitalCollection::AddHospital (CPoint ptFrom, CPoint ptTo, UINT nWidth, COLORREF crColor)
{
    CHospital* pHospital;
    try
	{
        pHospital = new CHospital (ptFrom, ptTo, nWidth, crColor);
        m_hospitalArray.Add(pHospital);
        //SetModifiedFlag();
    }
    catch (CMemoryException* error) 
	{
        if (pHospital != NULL) 
		{
            delete pHospital;
            pHospital = NULL;
        }
        AfxMessageBox ("Out of memory", MB_ICONSTOP | MB_OK);
        error->Delete ();
    }
    return pHospital;
}

void HospitalCollection::DeleteHospital (int index)
{
	m_hospitalArray.RemoveAt(index);
}

void HospitalCollection::DeleteHospitalContents ()
{
    int hospital_size = m_hospitalArray.GetSize ();

    if (hospital_size) 
	{
        for (int i=0; i<hospital_size; i++)
            delete m_hospitalArray[i];
        m_hospitalArray.RemoveAll ();
    }
}


CHospital* HospitalCollection::GetHospital (int nIndex)
{
    return (CHospital*) m_hospitalArray[nIndex];
}


int HospitalCollection::GetHospitalCount ()
{
    return m_hospitalArray.GetSize ();
}

void HospitalCollection::Serialize (CArchive& ar)
{
    CObject::Serialize(ar);
	m_hospitalArray.Serialize (ar);
}

CObArray* HospitalCollection::GetHospitalCollection()
{
	return (CObArray*) &m_hospitalArray;
}
