// HospitalMode.cpp: implementation of the CHospitalMode class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "map studio max r1.h"
#include "HospitalMode.h"
#include "HospitalView.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

IMPLEMENT_DYNAMIC(CHospitalMode, CMode)

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CHospitalMode::CHospitalMode(CMapDoc* doc)
:CMode(doc)
{
	hit = false;
	index =0;
}

CHospitalMode::~CHospitalMode()
{

}

CHospitalMode::OnLButtonDown(UINT nFlags, CPoint point, CDC* pDC)
{
	for (int n=0; ( (n<(_doc->hospital_collection->GetHospitalCount())) && !hit); n++)
		if (_doc->hospital_collection->GetHospital(n)->HitTest(point))
		{
			CHospitalView temp_hospital_view;
			hospital_selected = _doc->hospital_collection->GetHospital(n);
			temp_hospital_view.SelectedHospital(pDC, hospital_selected->GetStartingPoint(),
												     hospital_selected->GetEndPoint());
			index = n;
			hit = true;
		}
}

CHospitalMode::OnLButtonUp(UINT nFlags, CPoint point, CDC* pDC)
{
	CPoint m_ptFrom = GetView()->Getm_ptFrom();
	CHospital* pHospital = _doc->hospital_collection->AddHospital(m_ptFrom, point, 2, RGB(255, 255, 255));
	if (pHospital != NULL) 
	{
		CHospitalView* temp_hospital_view = new CHospitalView(pHospital);						
		temp_hospital_view->Draw(pDC);
		_doc->UpdateAllViews(GetView(), 0, pHospital);
		_doc->widgets_sequence.Add("hospital");
		_doc->SetModifiedFlag(TRUE);
	}
}

CHospitalMode::OnMouseMove_Move(UINT nFlags, CPoint point, CDC* pDC)
{
	CSize diff; //amount moved
	
	diff.cx = point.x - hospital_selected->GetStartingPoint().x;
	diff.cy = point.y - hospital_selected->GetStartingPoint().y;

	hospital_selected->SetStartingPoint(CPoint(point.x, point.y));
	hospital_selected->SetEndPoint( CPoint(hospital_selected->GetEndPoint().x + diff.cx, 
										   hospital_selected->GetEndPoint().y + diff.cy));
}

CHospitalMode::OnMouseMove_Draw(UINT nFlags, CPoint point, CDC* pDC)
{
	CHospitalView temp_hospital_view;
	
	CPoint m_ptFrom = GetView()->Getm_ptFrom();
	CPoint m_ptTo = GetView()->Getm_ptTo();
	
	temp_hospital_view.InvertHospital(pDC, m_ptFrom, m_ptTo);
	temp_hospital_view.InvertHospital(pDC, m_ptFrom, point);
}

CHospitalMode::OnMouseMove_Resize(UINT nFlags, CPoint point, CDC* pDC)
{
	CSize diff; //amount moved
	
	diff.cx = point.x - hospital_selected->GetStartingPoint().x;
	diff.cy = point.y - hospital_selected->GetStartingPoint().y;

	hospital_selected->SetEndPoint( CPoint(point.x, point.y));
}

void CHospitalMode::delete_selected()
{
	_doc->hospital_collection->DeleteHospital(index);
}

CHospitalMode::DoDialog()
{

}

bool CHospitalMode::IsHit()
{
	return hit;
}

CMapView* CHospitalMode::GetView() 
{
	POSITION pos = _doc->GetFirstViewPosition();
	return (CMapView*) _doc->GetNextView(pos);
}
