// HospitalView.cpp: implementation of the CHospitalView class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "map studio max r1.h"
#include "HospitalView.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CHospitalView::CHospitalView()
{

}

CHospitalView::CHospitalView(CHospital* hospital)
{
	m_StartingPoint = hospital->GetStartingPoint();
    m_EndPoint = hospital->GetEndPoint();
    m_LineWidth = hospital->GetLineWidth();
    m_LineColor = hospital->GetLineColor();
}

CHospitalView::~CHospitalView()
{

}

void CHospitalView::Draw (CDC* pDC)
{
	//draw rect
    CBrush brush;
	brush.CreateSolidBrush(RGB(255,255,255));
	CPen pen (PS_SOLID, m_LineWidth, m_LineColor);
    CPen* pOldPen = pDC->SelectObject (&pen);

	pDC->SelectObject (&brush);
	pDC->SelectObject (&pen);
    pDC->Rectangle(m_StartingPoint.x, m_StartingPoint.y, m_EndPoint.x, m_EndPoint.y);
	
	pDC->SelectObject (pOldPen);

	//draw cross
	int diffx = m_EndPoint.x - m_StartingPoint.x;
	int diffy = m_EndPoint.y - m_StartingPoint.y;


	CPoint middlePt(m_StartingPoint.x + (diffx/2), m_StartingPoint.y + (diffy/2));

	CPen cross_pen (PS_SOLID, 3, RGB(255,0,0));
    pOldPen = pDC->SelectObject (&cross_pen);
	// up 
	pDC->MoveTo(CPoint( middlePt.x, middlePt.y));
	pDC->LineTo(CPoint( middlePt.x, middlePt.y - 5));	
	// down
	pDC->MoveTo(CPoint( middlePt.x, middlePt.y));
	pDC->LineTo(CPoint( middlePt.x, middlePt.y + 5));	
	// left
	pDC->MoveTo(CPoint( middlePt.x, middlePt.y));
	pDC->LineTo(CPoint( middlePt.x - 5, middlePt.y));	
	//right
	pDC->MoveTo(CPoint( middlePt.x, middlePt.y));
	pDC->LineTo(CPoint( middlePt.x + 5, middlePt.y));	

	pDC->SelectObject (pOldPen);
}

void CHospitalView::InvertHospital(CDC* pDC, CPoint ptFrom, CPoint ptTo)
{
    int nOldMode = pDC->SetROP2 (R2_NOTXORPEN);
    pDC->Rectangle(ptFrom.x, ptFrom.y, ptTo.x, ptTo.y);
    pDC->SetROP2 (nOldMode);
}

void CHospitalView::SelectedHospital (CDC* pDC, CPoint ptFrom, CPoint ptTo)
{
	CPoint ptFrom_upperLeft, ptFrom_lowerRight, ptTo_upperLeft, ptTo_lowerRight;
	
	ptFrom_upperLeft = CPoint(ptFrom.x-3, ptFrom.y-3);
	ptFrom_lowerRight = CPoint(ptFrom.x+3, ptFrom.y+3);
	ptTo_upperLeft = CPoint(ptTo.x-3, ptTo.y-3);
	ptTo_lowerRight = CPoint(ptTo.x+3, ptTo.y+3);

	CPen pen (PS_SOLID, 3, RGB(0,0,0));
    CPen* pOldPen = pDC->SelectObject (&pen);
	pDC->SelectObject (&pen);

	pDC->Rectangle(ptFrom_upperLeft.x, ptFrom_upperLeft.y, ptFrom_lowerRight.x, ptFrom_lowerRight.y);
	pDC->Rectangle(ptTo_upperLeft.x, ptTo_upperLeft.y, ptTo_lowerRight.x, ptTo_lowerRight.y);

	pDC->SelectObject (pOldPen);
}
