// LineCollection.cpp: implementation of the LineCollection class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Map Studio MAX R1.h"
#include "LineCollection.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////
IMPLEMENT_SERIAL (LineCollection, CObject, 1)

LineCollection::LineCollection()
{

}

LineCollection::~LineCollection()
{

}

CLine* LineCollection::AddLine (CPoint ptFrom, CPoint ptTo, UINT nWidth, COLORREF crColor)
{
    CLine* pLine;
    try 
	{
        pLine = new CLine (ptFrom, ptTo, nWidth, crColor);
        m_lineArray.Add (pLine);
        //SetModifiedFlag();
    }
    catch (CMemoryException* error)
	{
        if (pLine != NULL) 
		{
			delete pLine;
            pLine = NULL;
        }
        AfxMessageBox ("Out of memory", MB_ICONSTOP | MB_OK);
        error->Delete ();
    }
    return pLine;
}

void LineCollection::DeleteLine (int index)
{
	m_lineArray.RemoveAt(index);
}

void LineCollection::DeleteLineContents ()
{
    int line_size = m_lineArray.GetSize ();

    if (line_size) 
	{
        for (int i=0; i<line_size; i++)
            delete m_lineArray[i];
        m_lineArray.RemoveAll ();
    }
}


CLine* LineCollection::GetLine (int nIndex)
{
    return (CLine*) m_lineArray[nIndex];
}


int LineCollection::GetLineCount ()
{
    return m_lineArray.GetSize ();
}


void LineCollection::Serialize (CArchive& ar)
{
    CObject::Serialize (ar);
	m_lineArray.Serialize (ar);
}


CObArray* LineCollection::GetLineCollection()
{
	return (CObArray*) &m_lineArray;
}
