// LineMode.cpp: implementation of the CLineMode class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Map Studio MAX R1.h"
#include "LineMode.h"
#include "LineView.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

IMPLEMENT_DYNAMIC(CLineMode, CMode)

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CLineMode::CLineMode(CMapDoc* doc)
:CMode(doc)
{
	index = 0;
	hit = false;
}

CLineMode::~CLineMode()
{

}

CLineMode::OnLButtonDown(UINT nFlags, CPoint point, CDC* pDC)
{
	for (int n=0; ( (n<(_doc->line_collection->GetLineCount())) && !hit); n++)
		if (_doc->line_collection->GetLine(n)->HitTest(point))
		{
			CLineView temp_line_view;
			line_selected = _doc->line_collection->GetLine(n);
			temp_line_view.SelectedLine(pDC, line_selected->GetStartingPoint(),
										line_selected->GetEndPoint());
			index = n;
			hit = true;
		}
}

CLineMode::OnLButtonUp(UINT nFlags, CPoint point, CDC* pDC)
{
	CPoint m_ptFrom = GetView()->Getm_ptFrom();
	CLine* pLine = _doc->line_collection->AddLine(m_ptFrom, point, 2, RGB(102,51,0));
	if (pLine != NULL) 
	{
		CLineView* temp_line_view = new CLineView(pLine);						
		temp_line_view->Draw(pDC);
		_doc->UpdateAllViews(GetView(), 0, pLine);
		_doc->widgets_sequence.Add("line");
		_doc->SetModifiedFlag(TRUE);
	}
}

CLineMode::OnMouseMove_Move(UINT nFlags, CPoint point, CDC* pDC)
{
	CSize diff; //amount moved
	
	diff.cx = point.x - line_selected->GetStartingPoint().x;
	diff.cy = point.y - line_selected->GetStartingPoint().y;

	line_selected->SetStartingPoint(CPoint(point.x, point.y));
	line_selected->SetEndPoint( CPoint(line_selected->GetEndPoint().x + diff.cx, 
								line_selected->GetEndPoint().y + diff.cy));
}

CLineMode::OnMouseMove_Draw(UINT nFlags, CPoint point, CDC* pDC)
{
	CLineView temp_line_view;
	
	CPoint m_ptFrom = GetView()->Getm_ptFrom();
	CPoint m_ptTo = GetView()->Getm_ptTo();
		
	temp_line_view.InvertLine(pDC, m_ptFrom, m_ptTo);
	temp_line_view.InvertLine(pDC, m_ptFrom, point);
}

CLineMode::OnMouseMove_Resize(UINT nFlags, CPoint point, CDC* pDC)
{
	CSize diff; //amount moved
	
	diff.cx = point.x - line_selected->GetStartingPoint().x;
	diff.cy = point.y - line_selected->GetStartingPoint().y;

	line_selected->SetEndPoint( CPoint(point.x, point.y));
}

void CLineMode::delete_selected()
{
	_doc->line_collection->DeleteLine(index);
}

CLineMode::DoDialog()
{

}

bool CLineMode::IsHit()
{
	return hit;
}

CMapView* CLineMode::GetView() 
{
	POSITION pos = _doc->GetFirstViewPosition();
	return (CMapView*) _doc->GetNextView(pos);
}
