// LineView.cpp: implementation of the CLineView class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Map Studio MAX R1.h"
#include "LineView.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CLineView::CLineView()
{

}

CLineView::CLineView(CLine* line)
{
	m_StartingPoint = line->GetStartingPoint();
    m_EndPoint = line->GetEndPoint();
    m_LineWidth = line->GetLineWidth();
    m_LineColor = line->GetLineColor();
}


CLineView::~CLineView()
{

}

void CLineView::Draw (CDC* pDC)
{
    CPen pen (PS_SOLID, m_LineWidth, m_LineColor);
    CPen* pOldPen = pDC->SelectObject (&pen);
	pDC->SelectObject (&pen);
	pDC->MoveTo(m_StartingPoint);
    pDC->LineTo(m_EndPoint);

	pDC->SelectObject (pOldPen);
}

void CLineView::InvertLine (CDC* pDC, CPoint ptFrom, CPoint ptTo)
{
    int nOldMode = pDC->SetROP2 (R2_NOTXORPEN);
    pDC->MoveTo (ptFrom);
    pDC->LineTo (ptTo);
    pDC->SetROP2 (nOldMode);
}

void CLineView::SelectedLine (CDC* pDC, CPoint ptFrom, CPoint ptTo)
{
	CPoint ptFrom_upperLeft, ptFrom_lowerRight, ptTo_upperLeft, ptTo_lowerRight;
	
	ptFrom_upperLeft = CPoint(ptFrom.x-3, ptFrom.y-3);
	ptFrom_lowerRight = CPoint(ptFrom.x+3, ptFrom.y+3);
	ptTo_upperLeft = CPoint(ptTo.x-3, ptTo.y-3);
	ptTo_lowerRight = CPoint(ptTo.x+3, ptTo.y+3);

	CPen pen (PS_SOLID, 3, RGB(0,0,0));
    CPen* pOldPen = pDC->SelectObject (&pen);
	pDC->SelectObject (&pen);

	pDC->Rectangle(ptFrom_upperLeft.x, ptFrom_upperLeft.y, ptFrom_lowerRight.x, ptFrom_lowerRight.y);
	pDC->Rectangle(ptTo_upperLeft.x, ptTo_upperLeft.y, ptTo_lowerRight.x, ptTo_lowerRight.y);

	pDC->SelectObject (pOldPen);
}
