// MapDoc.cpp : implementation of the CMapDoc class
//

#include "stdafx.h"
#include "Map Studio MAX R1.h"

#include "MapDoc.h"
#include "MapSettingDlg.h"
#include "MapView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMapDoc

IMPLEMENT_DYNCREATE(CMapDoc, CDocument)

BEGIN_MESSAGE_MAP(CMapDoc, CDocument)
	//{{AFX_MSG_MAP(CMapDoc)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMapDoc construction/destruction

CMapDoc::CMapDoc()
{
	doc_size_horizontal = 780;
	doc_size_vertical = 430;
	line_collection = new LineCollection;
	rect_collection = new RectCollection;
	circle_collection = new CircleCollection;
	road_collection = new RoadCollection;
	bridge_collection = new BridgeCollection;
	text_collection = new TextCollection;
	rail_collection = new RailCollection;
	highway_collection = new HighWayCollection;
	hospital_collection = new HospitalCollection;
}

CMapDoc::~CMapDoc()
{
}

BOOL CMapDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	// TODO: add reinitialization code here
	// (SDI documents will reuse this document)
	map = CSize(doc_size_horizontal, doc_size_vertical);
	return TRUE;
}


/////////////////////////////////////////////////////////////////////////////
// CMapDoc serialization

void CMapDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		ar << map;
		ar << doc_size_horizontal;
		ar << doc_size_vertical;
	}
	else
	{
		ar >> map;
		ar >> doc_size_horizontal;
		ar >> doc_size_vertical;
	}
	CObArray* lines = line_collection->GetLineCollection();
	CObArray* rects = rect_collection->GetRectCollection();
	CObArray* circles = circle_collection->GetCircleCollection();
	CObArray* roads = road_collection->GetRoadCollection();
	CObArray* bridges = bridge_collection->GetBridgeCollection();
	CObArray* texts = text_collection->GetTextCollection();
	CObArray* rails = rail_collection->GetRailCollection();
	CObArray* highways = highway_collection->GetHighWayCollection();
	CObArray* hospitals = hospital_collection->GetHospitalCollection();
		
	widgets_sequence.Serialize(ar);
	lines->Serialize(ar);
	rects->Serialize(ar);
	circles->Serialize(ar);
	roads->Serialize(ar);
	bridges->Serialize(ar);
	texts->Serialize(ar);
	rails->Serialize(ar);
	highways->Serialize(ar);
	hospitals->Serialize(ar);
}

/////////////////////////////////////////////////////////////////////////////
// CMapDoc diagnostics

#ifdef _DEBUG
void CMapDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CMapDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG





