// MapDoc.h : interface of the CMapDoc class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_MAPDOC_H__0D059D2D_2EF3_11D5_A20E_FDFEBC7F8D4A__INCLUDED_)
#define AFX_MAPDOC_H__0D059D2D_2EF3_11D5_A20E_FDFEBC7F8D4A__INCLUDED_

#include "LineCollection.h"
#include "ricleCollection.h"
#include "RectCollection.h"
#include "RoadCollection.h"
#include "BridgeCollection.h"
#include "TextCollection.h"
#include "RailCollection.h"
#include "HighWayCollection.h"
#include "HospitalCollection.h"

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


class CMapDoc : public CDocument
{
protected: // create from serialization only
	CMapDoc();
	DECLARE_DYNCREATE(CMapDoc)
	
// Attributes
public:
	CSize map;
	UINT doc_size_horizontal;
	UINT doc_size_vertical;
	CStringArray widgets_sequence;

	LineCollection* line_collection;	
	RectCollection* rect_collection;
	CircleCollection* circle_collection;
	RoadCollection* road_collection;
	BridgeCollection* bridge_collection;
	TextCollection* text_collection;
	RailCollection* rail_collection;
	HighWayCollection* highway_collection;
	HospitalCollection* hospital_collection;


// Operations
public:



// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMapDoc)
	public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CMapDoc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CMapDoc)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MAPDOC_H__0D059D2D_2EF3_11D5_A20E_FDFEBC7F8D4A__INCLUDED_)
