// MapView.cpp : implementation of the CMapView class
//

#include "stdafx.h"
#include "Map Studio MAX R1.h"

#include "MapDoc.h"
#include "MapView.h"

#include "Lineview.h"
#include "RectView.h"
#include "CircleView.h"
#include "BridgeView.h"
#include "RoadView.h"
#include "HighWayView.h"
#include "TextView.h"
#include "RailView.h"
#include "HospitalView.h"
#include "ImageWnd.h"

#include "MapSettingDlg.h"
#include "ListNamesDlg.h"
#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMapView

IMPLEMENT_DYNCREATE(CMapView, CScrollView)

BEGIN_MESSAGE_MAP(CMapView, CScrollView)
	//{{AFX_MSG_MAP(CMapView)
	ON_COMMAND(ID_MAGNIFY, OnMagnify)
	ON_UPDATE_COMMAND_UI(ID_MAGNIFY, OnUpdateMagnify)
	ON_WM_SIZE()
	ON_WM_LBUTTONDOWN()
	ON_WM_MOUSEMOVE()
	ON_WM_LBUTTONUP()
	ON_COMMAND(ID_BUTTON_DRAW_RECT, OnButtonDrawRect)
	ON_COMMAND(ID_BUTTON_DRAW_LINE, OnButtonDrawLine)
	ON_COMMAND(ID_EDIT_MAP_SETTING, OnEditMapSetting)
	ON_COMMAND(ID_BUTTON_DRAW_CIR, OnButtonDrawCir)
	ON_COMMAND(ID_BUTTON_DRAW_ROAD, OnButtonDrawRoad)
	ON_COMMAND(ID_BUTTON_DRAW_BRIDGE, OnButtonDrawBridge)
	ON_COMMAND(ID_BUTTON_SELECT_OBJECT, OnButtonSelectObject)
	ON_COMMAND(ID_BUTTON_MOVE, OnButtonMove)
	ON_WM_CONTEXTMENU()
	ON_WM_ERASEBKGND()
	ON_UPDATE_COMMAND_UI(ID_BUTTON_DRAW_BRIDGE, OnUpdateButtonDrawBridge)
	ON_UPDATE_COMMAND_UI(ID_BUTTON_DRAW_CIR, OnUpdateButtonDrawCir)
	ON_UPDATE_COMMAND_UI(ID_BUTTON_DRAW_LINE, OnUpdateButtonDrawLine)
	ON_UPDATE_COMMAND_UI(ID_BUTTON_DRAW_RECT, OnUpdateButtonDrawRect)
	ON_UPDATE_COMMAND_UI(ID_BUTTON_DRAW_ROAD, OnUpdateButtonDrawRoad)
	ON_COMMAND(ID_BUTTON_ENTER_TEXT, OnButtonEnterText)
	ON_UPDATE_COMMAND_UI(ID_BUTTON_ENTER_TEXT, OnUpdateButtonEnterText)
	ON_UPDATE_COMMAND_UI(ID_BUTTON_SELECT_OBJECT, OnUpdateButtonSelectObject)
	ON_UPDATE_COMMAND_UI(ID_BUTTON_MOVE, OnUpdateButtonMove)
	ON_WM_KEYDOWN()
	ON_COMMAND(ID_BUTTON_RESIZE, OnButtonResize)
	ON_UPDATE_COMMAND_UI(ID_BUTTON_RESIZE, OnUpdateButtonResize)
	ON_COMMAND(ID_BUTTON_DRAW_RAIL, OnButtonDrawRail)
	ON_UPDATE_COMMAND_UI(ID_BUTTON_DRAW_RAIL, OnUpdateButtonDrawRail)
	ON_COMMAND(ID_BUTTON_OBJ_LIST, OnButtonObjList)
	ON_COMMAND(ID_BUTTON_DRAW_HIGHWAY, OnButtonDrawHighway)
	ON_UPDATE_COMMAND_UI(ID_BUTTON_DRAW_HIGHWAY, OnUpdateButtonDrawHighway)
	ON_COMMAND(ID_BUTTON_DRAW_HOSPITAL, OnButtonDrawHospital)
	ON_UPDATE_COMMAND_UI(ID_BUTTON_DRAW_HOSPITAL, OnUpdateButtonDrawHospital)
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CScrollView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CScrollView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CScrollView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMapView construction/destruction

CMapView::CMapView()
{
	move = FALSE;
	select = FALSE;
	draw = FALSE;
	resize= FALSE;
	m_pSelectedMode = NULL;
	m_resize = FALSE;
	m_bridge=FALSE;
	m_line=FALSE;
	m_rectangle=FALSE;
	m_road=FALSE;
	m_circle=FALSE;
	m_text=FALSE;
	m_select=FALSE;
	m_move=FALSE;
	m_rail=FALSE;
	m_highway=FALSE;
	m_hospital=FALSE;
}

CMapView::~CMapView()
{
}

BOOL CMapView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CScrollView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CMapView drawing

void CMapView::OnDraw(CDC* pDC)
{
	CMapDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	int number_of_line = pDoc->line_collection->GetLineCount();
	int number_of_rect = pDoc->rect_collection->GetRectCount();
	int number_of_circle = pDoc->circle_collection->GetCircleCount();
	int number_of_bridge = pDoc->bridge_collection->GetBridgeCount();
	int number_of_road = pDoc->road_collection->GetRoadCount();
	int number_of_text = pDoc->text_collection->GetTextCount();
	int number_of_rail = pDoc->rail_collection->GetRailCount();
	int number_of_highway = pDoc->highway_collection->GetHighWayCount();
	int number_of_hospital = pDoc->hospital_collection->GetHospitalCount();

	int line_index = 0;
	int rect_index = 0;
	int circle_index = 0;
	int road_index = 0;
	int bridge_index = 0;
	int text_index = 0;
	int rail_index = 0;
	int highway_index = 0;
	int hospital_index = 0;

	int number_of_widget = pDoc->widgets_sequence.GetSize();
	for (int n = 0; n< number_of_widget; n++)
	{
		if ((pDoc->widgets_sequence[n])=="line")
		{
			if (line_index < number_of_line)
			{
				CLine* temp_line;
				temp_line = pDoc->line_collection->GetLine(line_index);
				CLineView* temp_line_view = new CLineView(temp_line);
				temp_line_view->Draw(pDC);
				line_index++;
			}
		};

		if ((pDoc->widgets_sequence[n])=="rect")
		{
			if (rect_index < number_of_rect)
			{
				CRectangle* temp_rect;
				temp_rect = pDoc->rect_collection->GetRect(rect_index);
				CRectView* temp_rect_view = new CRectView(temp_rect);
				temp_rect_view->Draw(pDC);
				rect_index++;
			}
		};

		if ((pDoc->widgets_sequence[n])=="circle")
		{
			if (circle_index < number_of_circle)
			{
				CCircle* temp_circle;
				temp_circle = pDoc->circle_collection->GetCircle(circle_index);
				CCircleView* temp_circle_view = new CCircleView(temp_circle);
				temp_circle_view->Draw(pDC);
				circle_index++;
			}
		};

		if ((pDoc->widgets_sequence[n])=="road")
		{
			if (road_index < number_of_road)
			{
				CRoad* temp_road;
				temp_road = pDoc->road_collection->GetRoad(road_index);
				CRoadView* temp_road_view = new CRoadView(temp_road);
				temp_road_view->Draw(pDC);
				road_index++;
			}
		};

		if ((pDoc->widgets_sequence[n])=="bridge")
		{
			if (bridge_index < number_of_bridge)
			{
				CBridge* temp_bridge;
				temp_bridge = pDoc->bridge_collection->GetBridge(bridge_index);
				CBridgeView* temp_bridge_view = new CBridgeView(temp_bridge);
				temp_bridge_view->Draw(pDC);
				bridge_index++;
			}
		};

		if ((pDoc->widgets_sequence[n])=="text")
		{
			if (text_index < number_of_text)
			{
				CText* temp_text;
				temp_text = pDoc->text_collection->GetText(text_index);
				CTextView* temp_text_view = new CTextView(temp_text);
				temp_text_view->Draw(pDC);
				text_index++;
			}
		};

		if ((pDoc->widgets_sequence[n])=="rail")
		{
			if (rail_index < number_of_rail)
			{
				CRail* temp_rail;
				temp_rail = pDoc->rail_collection->GetRail(rail_index);
				CRailView* temp_rail_view = new CRailView(temp_rail);
				temp_rail_view->Draw(pDC);
				rail_index++;
			}
		};

		if ((pDoc->widgets_sequence[n])=="highway")
		{
			if (highway_index < number_of_highway)
			{
				CHighWay* temp_highway;
				temp_highway = pDoc->highway_collection->GetHighWay(highway_index);
				CHighWayView* temp_highway_view = new CHighWayView(temp_highway);
				temp_highway_view->Draw(pDC);
				highway_index++;
			}
		};

		if ((pDoc->widgets_sequence[n])=="hospital")
		{
			if (hospital_index < number_of_hospital)
			{
				CHospital* temp_hospital;
				temp_hospital = pDoc->hospital_collection->GetHospital(hospital_index);
				CHospitalView* temp_hospital_view = new CHospitalView(temp_hospital);
				temp_hospital_view->Draw(pDC);
				hospital_index++;
			}
		};
	};
	ReleaseDC(pDC);
	//update the document size
	UpdateDocumentSize();
}

void CMapView::OnInitialUpdate()
{
	CScrollView::OnInitialUpdate();
	document_size = GetDocument()->map;
	SetScrollSizes(MM_TEXT, document_size);

	
	CRect rect;
	GetClientRect(&rect);
	m_imageWnd.Create(AfxRegisterWndClass( NULL, NULL, (HBRUSH) GetStockObject(NULL_BRUSH)), NULL, WS_CHILD, rect, this, 0xffff);
	m_imageWnd.SetWindowPos( &wndTop, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE);

}

/////////////////////////////////////////////////////////////////////////////
// CMapView printing

BOOL CMapView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CMapView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CMapView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

/////////////////////////////////////////////////////////////////////////////
// CMapView diagnostics

#ifdef _DEBUG
void CMapView::AssertValid() const
{
	CScrollView::AssertValid();
}

void CMapView::Dump(CDumpContext& dc) const
{
	CScrollView::Dump(dc);
}

CMapDoc* CMapView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CMapDoc)));
	return (CMapDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMapView message handlers

void CMapView::OnLButtonDown(UINT nFlags, CPoint point) 
{
	CClientDC dc (this);
    OnPrepareDC (&dc);
    dc.DPtoLP (&point);

	if(draw)
	{	
		m_ptFrom = point;
		m_ptTo = point;
		ReleaseDC(&dc);
		SetCapture ();
	}

	//traverse through objects to do hit test
	if (select)
	{
		CMode *temp_selected_line, *temp_selected_rect, *temp_selected_circle,
			  *temp_selected_road, *temp_selected_bridge, *temp_selected_text,
			  *temp_selected_rail, *temp_selected_highway, *temp_selected_hospital;
		CMapDoc* pDoc = GetDocument();
		ASSERT_VALID(pDoc);

		temp_selected_line = new CLineMode(pDoc);
		temp_selected_line->OnLButtonDown(nFlags, point, &dc); 
		temp_selected_rect = new CRectMode(pDoc);
		temp_selected_rect->OnLButtonDown(nFlags, point, &dc);
		temp_selected_circle = new CCircleMode(pDoc);
		temp_selected_circle->OnLButtonDown(nFlags, point, &dc);
		temp_selected_road = new CRoadMode(pDoc);
		temp_selected_road->OnLButtonDown(nFlags, point, &dc);
		temp_selected_bridge = new CBridgeMode(pDoc);
		temp_selected_bridge->OnLButtonDown(nFlags, point, &dc);
		temp_selected_text = new CTextMode(pDoc);
		temp_selected_text->OnLButtonDown(nFlags, point, &dc);
		temp_selected_rail = new CRailMode(pDoc);
		temp_selected_rail->OnLButtonDown(nFlags, point, &dc);
		temp_selected_highway = new CHighWayMode(pDoc);
		temp_selected_highway->OnLButtonDown(nFlags, point, &dc);
		temp_selected_hospital = new CHospitalMode(pDoc);
		temp_selected_hospital->OnLButtonDown(nFlags, point, &dc);

		if (temp_selected_line->IsHit()) m_pSelectedMode = temp_selected_line;
		if (temp_selected_rect->IsHit()) m_pSelectedMode = temp_selected_rect;
		if (temp_selected_circle->IsHit()) m_pSelectedMode = temp_selected_circle;
		if (temp_selected_road->IsHit()) m_pSelectedMode = temp_selected_road;
		if (temp_selected_bridge->IsHit()) m_pSelectedMode = temp_selected_bridge;
		if (temp_selected_text->IsHit()) m_pSelectedMode = temp_selected_text;
		if (temp_selected_rail->IsHit()) m_pSelectedMode = temp_selected_rail;
		if (temp_selected_highway->IsHit()) m_pSelectedMode = temp_selected_highway;
		if (temp_selected_hospital->IsHit()) m_pSelectedMode = temp_selected_hospital;
	
		if (m_pSelectedMode!=NULL)
			m_pSelectedMode->OnLButtonDown(nFlags, point, &dc);
	}

}




void CMapView::OnMouseMove(UINT nFlags, CPoint point) 
{
	// to display the mouse cordinate on status bar
	CString strTemp;
	UINT nPaneID;
	UINT nPaneStyle;
	int nPaneWidth;

	// to display cursor cordinate on status bar
	CMainFrame* pFrame = (CMainFrame*) AfxGetApp()->m_pMainWnd;
	CStatusBar* pBar = &pFrame->m_wndStatusBar;
	if (pBar)
	{
		strTemp.Format("x=%d",point.x);
		pBar->GetPaneInfo(1,nPaneID,nPaneStyle,nPaneWidth);
		pBar->SetPaneText(1,strTemp);
		pBar->SetPaneInfo(1,nPaneID,nPaneStyle,7 * strTemp.GetLength());
		strTemp.Format("y=%d",point.y);
		pBar->GetPaneInfo(2,nPaneID,nPaneStyle,nPaneWidth);
		pBar->SetPaneText(2,strTemp);
		pBar->SetPaneInfo(2,nPaneID,nPaneStyle,7 * strTemp.GetLength());
		pFrame->RecalcLayout();
	}

	CView::OnMouseMove(nFlags, point);

	// moved selected widget
	if ( (move) && (m_pSelectedMode!=NULL) )
	{
		CMapDoc* pDoc = GetDocument();
		ASSERT_VALID(pDoc);

		CClientDC pdc (this);
		OnPrepareDC (&pdc);
		pdc.DPtoLP (&point);

		m_pSelectedMode->OnMouseMove_Move(nFlags, point, &pdc);
		this->RedrawWindow();
		ReleaseDC(&pdc);
	}

	// resize selected widget
	if ( (resize) && (m_pSelectedMode!=NULL) )
	{
		CMapDoc* pDoc = GetDocument();
		ASSERT_VALID(pDoc);

		CClientDC pdc (this);
		OnPrepareDC (&pdc);
		pdc.DPtoLP (&point);

		m_pSelectedMode->OnMouseMove_Resize(nFlags, point, &pdc);
		this->RedrawWindow();
		ReleaseDC(&pdc);
	}

	// for displaying the inverted line when drawing primitive 
    if ( (GetCapture () == this) && (m_pSelectedMode!=NULL) && (draw) && (!select) && (!move) && (!resize))
	{
        CClientDC dc (this);
        OnPrepareDC (&dc);
        dc.DPtoLP (&point);
		
		CPen DotPen(PS_DOT, 1, RGB(0,0,0));
		dc.SelectObject(&DotPen);
		
		m_pSelectedMode->OnMouseMove_Draw(nFlags, point, &dc);
		m_ptTo = point;

		DeleteObject(DotPen);
		ReleaseDC(&dc);
	}	
}



void CMapView::OnLButtonUp(UINT nFlags, CPoint point) 
{
	// reset select and move mode to draw mode
	if (move || resize)
	{
		move = FALSE;
		draw = FALSE;
		resize = FALSE;
		select = TRUE;
		return;
	}
	
	if ( (GetCapture () == this) && (m_pSelectedMode!=NULL) && (draw) && (!select) && (!move)) 
	{
		ReleaseCapture();
		CClientDC dc (this);
		OnPrepareDC (&dc);
		dc.DPtoLP (&point);
		m_pSelectedMode->OnLButtonUp(nFlags, point, &dc);
		ReleaseDC(&dc);
		if (!(m_pSelectedMode->IsKindOf(RUNTIME_CLASS(CTextMode))))
		{
			move =FALSE;
			draw =TRUE;
			resize = FALSE;
			select = FALSE;
			return;
		}
	}
	move = FALSE;
	resize = FALSE;
	select = FALSE;
	draw = FALSE;
}



void CMapView::OnMagnify()
{
	m_bMagn = m_bMagn?FALSE:TRUE;
	m_imageWnd.ShowWindow(m_bMagn ? SW_SHOW:SW_HIDE );
}


void CMapView::OnUpdateMagnify(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->SetCheck(m_bMagn?1:0);
}


void CMapView::OnSize(UINT nType, int cx, int cy) 
{
	CView::OnSize(nType, cx, cy);
	
	// TODO: Add your message handler code here
	//This part is critical for  Magnifying Glass.
	if (m_imageWnd.m_hWnd)
	{
		CRect rect;
		GetClientRect(rect);
		m_imageWnd.MoveWindow(rect,FALSE);
	}

}


void CMapView::OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint) 
{
	if (pHint != NULL) 
	{
        CClientDC dc (this);
        OnPrepareDC (&dc);
        ((CLineView*) pHint)->Draw (&dc);
		((CRectView*) pHint)->Draw (&dc);
		((CCircleView*) pHint)->Draw (&dc);
		((CRoadView*) pHint)->Draw (&dc);
		((CBridgeView*) pHint)->Draw (&dc);
		((CTextView*) pHint)->Draw (&dc);
		((CRailView*) pHint)->Draw (&dc);
		((CHighWayView*) pHint)->Draw (&dc);
		((CHospitalView*) pHint)->Draw (&dc);
		ReleaseDC(&dc);
        return;
    }
	CScrollView::OnUpdate (pSender, lHint, pHint);
}

void CMapView::OnEditMapSetting() 
{
	CMapSettingDlg MapDlg;
	
	MapDlg.m_horizontal = GetDocument()->doc_size_horizontal;
	MapDlg.m_vertical = GetDocument()->doc_size_vertical;
	if ((MapDlg.DoModal()) == IDOK)
	{
		//Update CMapDoc 's document size
		GetDocument()->doc_size_horizontal = MapDlg.m_horizontal;
		GetDocument()->doc_size_vertical = MapDlg.m_vertical;
	
		//Update document size after new settings
		UpdateDocumentSize();
	};
}

void CMapView::UpdateDocumentSize()
{
	document_size = CSize( GetDocument()->doc_size_horizontal, 
						   GetDocument()->doc_size_vertical);
	SetScrollSizes(MM_TEXT, document_size);
}

void CMapView::OnButtonDrawBridge() 
{
	m_bridge=TRUE;
	m_line=FALSE;
	m_rectangle=FALSE;
	m_road=FALSE;
	m_circle=FALSE;
	m_text=FALSE;
	m_move=FALSE;
	m_select=FALSE;
	m_resize=FALSE;
	m_rail=FALSE;
	m_highway=FALSE;
	m_hospital=FALSE;
	resize = FALSE;
	move = FALSE;
	select = FALSE;
	draw = TRUE;

	CMapDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	m_pSelectedMode = NULL;
	ASSERT(m_pSelectedMode==NULL);
	m_pSelectedMode = new CBridgeMode(pDoc);
}

void CMapView::OnButtonDrawRoad() 
{
	m_road=TRUE;
	m_bridge=FALSE;
	m_line=FALSE;
	m_rectangle=FALSE;
	m_circle=FALSE;
	m_move=FALSE;
	m_select=FALSE;
	m_text=FALSE;
	m_highway=FALSE;
	m_hospital=FALSE;
	m_rail=FALSE;
	m_resize=FALSE;
	resize = FALSE;
	move = FALSE;
	select = FALSE;
	draw = TRUE;

	CMapDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	m_pSelectedMode = NULL;
	ASSERT(m_pSelectedMode==NULL);
	m_pSelectedMode = new CRoadMode(pDoc);
}

void CMapView::OnButtonDrawHighway() 
{
	m_road=FALSE;
	m_bridge=FALSE;
	m_line=FALSE;
	m_rectangle=FALSE;
	m_circle=FALSE;
	m_move=FALSE;
	m_select=FALSE;
	m_text=FALSE;
	m_highway=TRUE;
	m_hospital=FALSE;
	m_rail=FALSE;
	m_resize=FALSE;
	resize = FALSE;
	move = FALSE;
	select = FALSE;
	draw = TRUE;

	CMapDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	m_pSelectedMode = NULL;
	ASSERT(m_pSelectedMode==NULL);
	m_pSelectedMode = new CHighWayMode(pDoc);
}

void CMapView::OnButtonDrawCir() 
{
	m_circle=TRUE;
	m_bridge=FALSE;
	m_line=FALSE;
	m_road=FALSE;
	m_rectangle=FALSE;
	m_text=FALSE;
	m_rail=FALSE;
	m_move=FALSE;
	m_highway=FALSE;
	m_hospital=FALSE;
	m_select=FALSE;
	m_resize=FALSE;
	resize = FALSE;
	move = FALSE;
	select = FALSE;
	draw = TRUE;

	CMapDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	m_pSelectedMode = NULL;
	ASSERT(m_pSelectedMode==NULL);
	m_pSelectedMode = new CCircleMode(pDoc);
}

void CMapView::OnButtonDrawRect() 
{
	m_rectangle=TRUE;
	m_line=FALSE;
	m_circle=FALSE;
	m_bridge=FALSE;
	m_road=FALSE;
	m_rail=FALSE;
	m_move=FALSE;
	m_select=FALSE;
	m_highway=FALSE;
	m_hospital=FALSE;
	m_text=FALSE;
	m_resize=FALSE;
	resize = FALSE;
	move = FALSE;
	select = FALSE;
	draw = TRUE;

	CMapDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	m_pSelectedMode = NULL;
	ASSERT(m_pSelectedMode==NULL);
	m_pSelectedMode = new CRectMode(pDoc);
}

void CMapView::OnButtonDrawLine() 
{
	m_line=TRUE;
	m_circle=FALSE;
	m_rectangle=FALSE;
	m_bridge=FALSE;
	m_road=FALSE;
	m_highway=FALSE;
	m_hospital=FALSE;
	m_text=FALSE;
	m_rail=FALSE;
	m_move=FALSE;
	m_select=FALSE;
	m_resize=FALSE;
	resize = FALSE;
	move = FALSE;
	select = FALSE;
	draw = TRUE;

	CMapDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	m_pSelectedMode = NULL;
	ASSERT(m_pSelectedMode==NULL);
	m_pSelectedMode = new CLineMode(pDoc);
}


void CMapView::OnButtonDrawHospital() 
{
	m_line=FALSE;
	m_circle=FALSE;
	m_rectangle=FALSE;
	m_bridge=FALSE;
	m_road=FALSE;
	m_highway=FALSE;
	m_hospital=TRUE;
	m_text=FALSE;
	m_rail=FALSE;
	m_move=FALSE;
	m_select=FALSE;
	m_resize=FALSE;
	resize = FALSE;
	move = FALSE;
	select = FALSE;
	draw = TRUE;

	CMapDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	m_pSelectedMode = NULL;
	ASSERT(m_pSelectedMode==NULL);
	m_pSelectedMode = new CHospitalMode(pDoc);
}

void CMapView::OnButtonDrawRail() 
{
	m_line=FALSE;
	m_circle=FALSE;
	m_rectangle=FALSE;
	m_bridge=FALSE;
	m_road=FALSE;
	m_highway=FALSE;
	m_hospital=FALSE;
	m_text=FALSE;
	m_move=FALSE;
	m_select=FALSE;
	m_resize=FALSE;
	m_rail=TRUE;
	resize = FALSE;
	move = FALSE;
	select = FALSE;
	draw = TRUE;

	CMapDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	m_pSelectedMode = NULL;
	ASSERT(m_pSelectedMode==NULL);
	m_pSelectedMode = new CRailMode(pDoc);
}

void CMapView::OnButtonEnterText() 
{
	m_line=FALSE;
	m_circle=FALSE;
	m_rectangle=FALSE;
	m_bridge=FALSE;
	m_road=FALSE;
	m_highway=FALSE;
	m_hospital=FALSE;
	m_text=TRUE;
	m_rail=FALSE;
	m_move=FALSE;
	m_select=FALSE;
	m_resize=FALSE;
	resize = FALSE;
	move = FALSE;
	select = FALSE;
	draw = TRUE;

	CMapDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	m_pSelectedMode = NULL;
	ASSERT(m_pSelectedMode==NULL);
	m_pSelectedMode = new CTextMode(pDoc);
	m_pSelectedMode->DoDialog();
}

void CMapView::OnButtonSelectObject() 
{
	m_line=FALSE;
	m_circle=FALSE;
	m_rectangle=FALSE;
	m_bridge=FALSE;
	m_road=FALSE;
	m_highway=FALSE;
	m_hospital=FALSE;
	m_text=FALSE;
	m_rail=FALSE;
	m_move=FALSE;
	m_select=TRUE;
	m_resize=FALSE;
	resize = FALSE;
	move = FALSE;
	select = TRUE;
	draw = FALSE;
}

void CMapView::OnButtonMove() 
{
	m_line=FALSE;
	m_circle=FALSE;
	m_rectangle=FALSE;
	m_bridge=FALSE;
	m_road=FALSE;
	m_highway=FALSE;
	m_hospital=FALSE;
	m_text=FALSE;
	m_rail=FALSE;
	m_move=TRUE;
	m_select=FALSE;
	m_resize=FALSE;
	resize = FALSE;
	move = TRUE;
	select = FALSE;
	draw = FALSE;
}

void CMapView::OnButtonResize() 
{
	m_line=FALSE;
	m_circle=FALSE;
	m_rectangle=FALSE;
	m_bridge=FALSE;
	m_road=FALSE;
	m_highway=FALSE;
	m_hospital=FALSE;
	m_text=FALSE;
	m_rail=FALSE;
	m_move=FALSE;
	m_select=FALSE;
	m_resize = TRUE;
	resize = TRUE;
	move = FALSE;
	select = FALSE;
	draw = FALSE;
}

void CMapView::OnContextMenu(CWnd* pWnd, CPoint point) 
{
    CMenu menu;
    menu.LoadMenu ("IDR_CONTEXTMENU");
    CMenu* pContextMenu = menu.GetSubMenu (0);
    pContextMenu->TrackPopupMenu (TPM_LEFTALIGN | TPM_LEFTBUTTON |
        TPM_RIGHTBUTTON, point.x, point.y, AfxGetMainWnd ());
	
}

BOOL CMapView::OnEraseBkgnd(CDC* pDC) 
{
    // Set brush to desired background color.
    CBrush backBrush(RGB(153, 153, 153));
    // Save old brush.
    CBrush* pOldBrush = pDC->SelectObject(&backBrush);
    CRect rect;
    pDC->GetClipBox(&rect);     // Erase the area needed.
    pDC->PatBlt(rect.left, rect.top, rect.Width(), 
    rect.Height(), PATCOPY);
    pDC->SelectObject(pOldBrush);
	ReleaseDC(pDC);
    return TRUE;
}

void CMapView::OnUpdateButtonDrawBridge(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(m_bridge);
}

void CMapView::OnUpdateButtonDrawCir(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(m_circle);		
}

void CMapView::OnUpdateButtonDrawLine(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(m_line);	
}

void CMapView::OnUpdateButtonDrawRect(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(m_rectangle);	
}

void CMapView::OnUpdateButtonDrawRoad(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(m_road);	
}

void CMapView::OnUpdateButtonDrawHighway(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(m_highway);	
}

void CMapView::OnUpdateButtonDrawHospital(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(m_hospital);
}

void CMapView::OnUpdateButtonEnterText(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(m_text);	
}

void CMapView::OnUpdateButtonDrawRail(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(m_rail);	
}

void CMapView::OnUpdateButtonSelectObject(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(m_select);			
}

void CMapView::OnUpdateButtonMove(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(m_move);	
}

void CMapView::OnUpdateButtonResize(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(m_resize);
}

CPoint CMapView::Getm_ptFrom()
{
	return m_ptFrom;
}

CPoint CMapView::Getm_ptTo()
{
	return m_ptTo;
}

void CMapView::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	if (nChar == 46)
	{
		if (m_pSelectedMode !=NULL )
		{
			m_pSelectedMode->delete_selected();
			m_pSelectedMode=NULL;
			this->RedrawWindow();
		}
	}
	
	CScrollView::OnKeyDown(nChar, nRepCnt, nFlags);
}


void CMapView::OnButtonObjList() 
{
	CListNamesDlg list_dlg(NULL, GetDocument());
	if (list_dlg.DoModal() == IDOK)
	{
		CTextView temp_text_view;
		CString search_obj = list_dlg.m_search;
		int num_texts = GetDocument()->text_collection->GetTextCount();

        CClientDC dc (this);
        OnPrepareDC (&dc);

		for (int n=0; n<num_texts; n++)
		{
			CString text = GetDocument()->text_collection->GetText(n)->GetText();
			if (text == search_obj)
			{
				temp_text_view.SelectedText(&dc, GetDocument()->text_collection->GetText(n)->GetStartingPoint(),
												 GetDocument()->text_collection->GetText(n)->GetEndPoint());
				this->RedrawWindow();
			}
		}

		ReleaseDC(&dc);
	}
}





