// MapView.h : interface of the CMapView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_MAPVIEW_H__0D059D2F_2EF3_11D5_A20E_FDFEBC7F8D4A__INCLUDED_)
#define AFX_MAPVIEW_H__0D059D2F_2EF3_11D5_A20E_FDFEBC7F8D4A__INCLUDED_

#include "Mode.h"

#include "Bridge.h"
#include "CLine.h"
#include "Rect.h"
#include "Circle.h"
#include "Road.h"
#include "Text.h"
#include "Rail.h"

#include "LineMode.h"
#include "RectMode.h"
#include "CircleMode.h"
#include "BridgeMode.h"
#include "RoadMode.h"
#include "HighWayMode.h"
#include "HospitalMode.h"
#include "TextMode.h"
#include "RailMode.h"
#include "ImageWnd.h"

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


class CMapView : public CScrollView
{
private:
	CPoint m_ptFrom;
    CPoint m_ptTo;
	CSize document_size;
	CMode* m_pSelectedMode;
	BOOL m_bridge, m_line, m_circle, m_rectangle, m_road, m_text;
	BOOL m_select, m_move, m_resize, m_rail, m_highway, m_hospital;
	BOOL draw, move, select, resize;

protected: // create from serialization only
	CMapView();
	DECLARE_DYNCREATE(CMapView)
	
// Attributes
public:
	CMapDoc* GetDocument();
	void UpdateDocumentSize();
	CPoint Getm_ptFrom();
	CPoint Getm_ptTo();

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMapView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	virtual void OnInitialUpdate(); // called first time after construct
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CMapView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:
	CImageWnd m_imageWnd;
	
// Generated message map functions
protected:
	BOOL m_bMagn;
	//{{AFX_MSG(CMapView)
	afx_msg void OnMagnify();
	afx_msg void OnUpdateMagnify(CCmdUI* pCmdUI);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnButtonDrawRect();
	afx_msg void OnButtonDrawLine();
	afx_msg void OnEditMapSetting();
	afx_msg void OnButtonDrawCir();
	afx_msg void OnButtonDrawRoad();
	afx_msg void OnButtonDrawBridge();
	afx_msg void OnButtonSelectObject();
	afx_msg void OnButtonMove();
	afx_msg void OnContextMenu(CWnd* pWnd, CPoint point);
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg void OnUpdateButtonDrawBridge(CCmdUI* pCmdUI);
	afx_msg void OnUpdateButtonDrawCir(CCmdUI* pCmdUI);
	afx_msg void OnUpdateButtonDrawLine(CCmdUI* pCmdUI);
	afx_msg void OnUpdateButtonDrawRect(CCmdUI* pCmdUI);
	afx_msg void OnUpdateButtonDrawRoad(CCmdUI* pCmdUI);
	afx_msg void OnButtonEnterText();
	afx_msg void OnUpdateButtonEnterText(CCmdUI* pCmdUI);
	afx_msg void OnUpdateButtonSelectObject(CCmdUI* pCmdUI);
	afx_msg void OnUpdateButtonMove(CCmdUI* pCmdUI);
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnButtonResize();
	afx_msg void OnUpdateButtonResize(CCmdUI* pCmdUI);
	afx_msg void OnButtonDrawRail();
	afx_msg void OnUpdateButtonDrawRail(CCmdUI* pCmdUI);
	afx_msg void OnButtonObjList();
	afx_msg void OnButtonDrawHighway();
	afx_msg void OnUpdateButtonDrawHighway(CCmdUI* pCmdUI);
	afx_msg void OnButtonDrawHospital();
	afx_msg void OnUpdateButtonDrawHospital(CCmdUI* pCmdUI);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in MapView.cpp
inline CMapDoc* CMapView::GetDocument()
   { return (CMapDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MAPVIEW_H__0D059D2F_2EF3_11D5_A20E_FDFEBC7F8D4A__INCLUDED_)
