// RailCollection.cpp: implementation of the RailCollection class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Map Studio MAX R1.h"
#include "RailCollection.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

IMPLEMENT_SERIAL (RailCollection, CObject, 1)

RailCollection::RailCollection()
{

}

RailCollection::~RailCollection()
{

}


CRail* RailCollection::AddRail (CPoint ptFrom, CPoint ptTo, UINT nWidth, COLORREF crColor)
{
    CRail* pRail;
    try 
	{
        pRail = new CRail (ptFrom, ptTo, nWidth, crColor);
        m_railArray.Add (pRail);
        //SetModifiedFlag();
    }
    catch (CMemoryException* error)
	{
        if (pRail != NULL) 
		{
			delete pRail;
            pRail = NULL;
        }
        AfxMessageBox ("Out of memory", MB_ICONSTOP | MB_OK);
        error->Delete ();
    }
    return pRail;
}

void RailCollection::DeleteRail (int index)
{
	m_railArray.RemoveAt(index);
}

void RailCollection::DeleteRailContents ()
{
    int rail_size = m_railArray.GetSize ();

    if (rail_size) 
	{
        for (int i=0; i<rail_size; i++)
            delete m_railArray[i];
        m_railArray.RemoveAll ();
    }
}


CRail* RailCollection::GetRail (int nIndex)
{
    return (CRail*) m_railArray[nIndex];
}


int RailCollection::GetRailCount ()
{
    return m_railArray.GetSize ();
}


void RailCollection::Serialize (CArchive& ar)
{
    CObject::Serialize (ar);
	m_railArray.Serialize (ar);
}


CObArray* RailCollection::GetRailCollection()
{
	return (CObArray*) &m_railArray;
}
