// RailMode.cpp: implementation of the CRailMode class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Map Studio MAX R1.h"
#include "RailMode.h"
#include "RailView.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif


IMPLEMENT_DYNAMIC(CRailMode, CMode)

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CRailMode::CRailMode(CMapDoc* doc)
:CMode(doc)
{
	index = 0;
	hit = false;
}

CRailMode::~CRailMode()
{

}

CRailMode::OnLButtonDown(UINT nFlags, CPoint point, CDC* pDC)
{
	for (int n=0; ( (n<(_doc->rail_collection->GetRailCount())) && !hit); n++)
		if (_doc->rail_collection->GetRail(n)->HitTest(point))
		{
			CRailView temp_rail_view;
			rail_selected = _doc->rail_collection->GetRail(n);
			temp_rail_view.SelectedRail(pDC, rail_selected->GetStartingPoint(),
										rail_selected->GetEndPoint());
			index = n;
			hit = true;
		}
}

CRailMode::OnLButtonUp(UINT nFlags, CPoint point, CDC* pDC)
{
	CPoint m_ptFrom = GetView()->Getm_ptFrom();
	CRail* pRail = _doc->rail_collection->AddRail(m_ptFrom, point, 7, RGB(102,102,102));
	if (pRail != NULL) 
	{
		CRailView* temp_rail_view = new CRailView(pRail);						
		temp_rail_view->Draw(pDC);
		_doc->UpdateAllViews(GetView(), 0, pRail);
		_doc->widgets_sequence.Add("rail");
		_doc->SetModifiedFlag(TRUE);
	}
}

CRailMode::OnMouseMove_Move(UINT nFlags, CPoint point, CDC* pDC)
{
	CSize diff; //amount moved
	
	diff.cx = point.x - rail_selected->GetStartingPoint().x;
	diff.cy = point.y - rail_selected->GetStartingPoint().y;

	rail_selected->SetStartingPoint(CPoint(point.x, point.y));
	rail_selected->SetEndPoint( CPoint(rail_selected->GetEndPoint().x + diff.cx, 
								rail_selected->GetEndPoint().y + diff.cy));
}

CRailMode::OnMouseMove_Draw(UINT nFlags, CPoint point, CDC* pDC)
{
	CRailView temp_rail_view;
	
	CPoint m_ptFrom = GetView()->Getm_ptFrom();
	CPoint m_ptTo = GetView()->Getm_ptTo();
		
	temp_rail_view.InvertRail(pDC, m_ptFrom, m_ptTo);
	temp_rail_view.InvertRail(pDC, m_ptFrom, point);
}

CRailMode::OnMouseMove_Resize(UINT nFlags, CPoint point, CDC* pDC)
{
	CSize diff; //amount moved
	
	diff.cx = point.x - rail_selected->GetStartingPoint().x;
	diff.cy = point.y - rail_selected->GetStartingPoint().y;

	rail_selected->SetEndPoint( CPoint(point.x, point.y));
}

void CRailMode::delete_selected()
{
	_doc->rail_collection->DeleteRail(index);
}

CRailMode::DoDialog()
{

}

bool CRailMode::IsHit()
{
	return hit;
}

CMapView* CRailMode::GetView() 
{
	POSITION pos = _doc->GetFirstViewPosition();
	return (CMapView*) _doc->GetNextView(pos);
}
