// RailView.cpp: implementation of the CRailView class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Map Studio MAX R1.h"
#include "RailView.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CRailView::CRailView()
{

}

CRailView::~CRailView()
{

}

CRailView::CRailView(CRail* rail)
{
	m_StartingPoint = rail->GetStartingPoint();
    m_EndPoint = rail->GetEndPoint();
    m_RailWidth = rail->GetRailWidth();
    m_RailColor = rail->GetRailColor();
}

void CRailView::Draw (CDC* pDC)
{
    CPen pen (PS_SOLID, m_RailWidth, m_RailColor);
    CPen* pOldPen = pDC->SelectObject (&pen);
	pDC->SelectObject (&pen);
	pDC->MoveTo(m_StartingPoint);
    pDC->LineTo(m_EndPoint);

	pDC->SelectObject (pOldPen);
}

void CRailView::InvertRail (CDC* pDC, CPoint ptFrom, CPoint ptTo)
{
    int nOldMode = pDC->SetROP2 (R2_NOTXORPEN);
    pDC->MoveTo (ptFrom);
    pDC->LineTo (ptTo);
    pDC->SetROP2 (nOldMode);
}

void CRailView::SelectedRail (CDC* pDC, CPoint ptFrom, CPoint ptTo)
{
	CPoint ptFrom_upperLeft, ptFrom_lowerRight, ptTo_upperLeft, ptTo_lowerRight;
	
	ptFrom_upperLeft = CPoint(ptFrom.x-3, ptFrom.y-3);
	ptFrom_lowerRight = CPoint(ptFrom.x+3, ptFrom.y+3);
	ptTo_upperLeft = CPoint(ptTo.x-3, ptTo.y-3);
	ptTo_lowerRight = CPoint(ptTo.x+3, ptTo.y+3);

	CPen pen (PS_SOLID, 3, RGB(255,255,255));
    CPen* pOldPen = pDC->SelectObject (&pen);
	pDC->SelectObject (&pen);

	pDC->Rectangle(ptFrom_upperLeft.x, ptFrom_upperLeft.y, ptFrom_lowerRight.x, ptFrom_lowerRight.y);
	pDC->Rectangle(ptTo_upperLeft.x, ptTo_upperLeft.y, ptTo_lowerRight.x, ptTo_lowerRight.y);

	pDC->SelectObject (pOldPen);
}
