// RectCollection.cpp: implementation of the RectCollection class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Map Studio MAX R1.h"
#include "RectCollection.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

IMPLEMENT_SERIAL (RectCollection, CObject, 1)

RectCollection::RectCollection()
{

}

RectCollection::~RectCollection()
{

}


CRectangle* RectCollection::AddRect (CPoint ptFrom, CPoint ptTo, UINT nWidth, COLORREF crColor)
{
    CRectangle* pRect;
    try
	{
        pRect = new CRectangle (ptFrom, ptTo, nWidth, crColor);
        m_rectArray.Add(pRect);
        //SetModifiedFlag();
    }
    catch (CMemoryException* error) 
	{
        if (pRect != NULL) 
		{
            delete pRect;
            pRect = NULL;
        }
        AfxMessageBox ("Out of memory", MB_ICONSTOP | MB_OK);
        error->Delete ();
    }
    return pRect;
}

void RectCollection::DeleteRect (int index)
{
	m_rectArray.RemoveAt(index);
}

void RectCollection::DeleteRectContents ()
{
    int rect_size = m_rectArray.GetSize ();

    if (rect_size) 
	{
        for (int i=0; i<rect_size; i++)
            delete m_rectArray[i];
        m_rectArray.RemoveAll ();
    }
}


CRectangle* RectCollection::GetRect (int nIndex)
{
    return (CRectangle*) m_rectArray[nIndex];
}


int RectCollection::GetRectCount ()
{
    return m_rectArray.GetSize ();
}

void RectCollection::Serialize (CArchive& ar)
{
    CObject::Serialize(ar);
	m_rectArray.Serialize (ar);
}

CObArray* RectCollection::GetRectCollection()
{
	return (CObArray*) &m_rectArray;
}