// RectMode.cpp: implementation of the CRectMode class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Map Studio MAX R1.h"
#include "RectMode.h"
#include "RectView.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

IMPLEMENT_DYNAMIC(CRectMode, CMode)

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CRectMode::CRectMode(CMapDoc* doc)
:CMode(doc)
{
	hit = false;
	index =0;
}

CRectMode::~CRectMode()
{

}

CRectMode::OnLButtonDown(UINT nFlags, CPoint point, CDC* pDC)
{
	for (int n =0; ( (n<(_doc->rect_collection->GetRectCount())) && !hit); n++)
		if (_doc->rect_collection->GetRect(n)->HitTest(point))
		{
			CRectView temp_rect_view;
			rect_selected = _doc->rect_collection->GetRect(n);
			temp_rect_view.SelectedRect(pDC, rect_selected->GetStartingPoint(),
										rect_selected->GetEndPoint());
			index = n;
			hit = true;
		}
}

CRectMode::OnLButtonUp(UINT nFlags, CPoint point, CDC* pDC)
{
	CPoint m_ptFrom = GetView()->Getm_ptFrom();
	CRectangle* pRect = _doc->rect_collection->AddRect(m_ptFrom, point, 2, RGB(255,153,0));
	if (pRect != NULL) 
	{
		CRectView* temp_rect_view = new CRectView(pRect);						
		temp_rect_view->Draw(pDC);
		_doc->UpdateAllViews(GetView(), 0, pRect);
		_doc->widgets_sequence.Add("rect");
		_doc->SetModifiedFlag(TRUE);
	}
}

CRectMode::OnMouseMove_Move(UINT nFlags, CPoint point, CDC* pDC)
{
	CSize diff; //amount moved
			
	diff.cx = point.x - rect_selected->GetStartingPoint().x;
	diff.cy = point.y - rect_selected->GetStartingPoint().y;

	rect_selected->SetStartingPoint(CPoint(point.x, point.y));
	rect_selected->SetEndPoint( CPoint(rect_selected->GetEndPoint().x + diff.cx, 
								rect_selected->GetEndPoint().y + diff.cy));
}

CRectMode::OnMouseMove_Draw(UINT nFlags, CPoint point, CDC* pDC)
{
	CRectView temp_rect_view;
	
	CPoint m_ptFrom = GetView()->Getm_ptFrom();
	CPoint m_ptTo = GetView()->Getm_ptTo();
	
	temp_rect_view.InvertRect(pDC, m_ptFrom, m_ptTo);
	temp_rect_view.InvertRect(pDC, m_ptFrom, point);
}

CRectMode::OnMouseMove_Resize(UINT nFlags, CPoint point, CDC* pDC)
{
	CSize diff; //amount moved
			
	diff.cx = point.x - rect_selected->GetStartingPoint().x;
	diff.cy = point.y - rect_selected->GetStartingPoint().y;

	rect_selected->SetEndPoint( CPoint(point.x, point.y));
}

void CRectMode::delete_selected()
{
	_doc->rect_collection->DeleteRect(index);
}

CRectMode::DoDialog()
{

}

bool CRectMode::IsHit()
{
	return hit;
}

CMapView* CRectMode::GetView() 
{
	POSITION pos = _doc->GetFirstViewPosition();
	return (CMapView*) _doc->GetNextView(pos);
}
