// RectView.cpp: implementation of the CRectView class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Map Studio MAX R1.h"
#include "RectView.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CRectView::CRectView()
{

}

CRectView::CRectView(CRectangle* rect)
{
	m_StartingPoint = rect->GetStartingPoint();
    m_EndPoint = rect->GetEndPoint();
    m_LineWidth = rect->GetLineWidth();
    m_LineColor = rect->GetLineColor();
}

CRectView::~CRectView()
{

}

void CRectView::Draw (CDC* pDC)
{
    CBrush brush;
	brush.CreateSolidBrush(RGB(255, 153, 0));
	CPen pen (PS_SOLID, m_LineWidth, m_LineColor);
    CPen* pOldPen = pDC->SelectObject (&pen);

	pDC->SelectObject (&brush);
	pDC->SelectObject (&pen);
    pDC->Rectangle(m_StartingPoint.x, m_StartingPoint.y, m_EndPoint.x, m_EndPoint.y);
	
	pDC->SelectObject (pOldPen);
}

void CRectView::InvertRect(CDC* pDC, CPoint ptFrom, CPoint ptTo)
{
    int nOldMode = pDC->SetROP2 (R2_NOTXORPEN);
    pDC->Rectangle(ptFrom.x, ptFrom.y, ptTo.x, ptTo.y);
    pDC->SetROP2 (nOldMode);
}

void CRectView::SelectedRect (CDC* pDC, CPoint ptFrom, CPoint ptTo)
{
	CPoint ptFrom_upperLeft, ptFrom_lowerRight, ptTo_upperLeft, ptTo_lowerRight;
	
	ptFrom_upperLeft = CPoint(ptFrom.x-3, ptFrom.y-3);
	ptFrom_lowerRight = CPoint(ptFrom.x+3, ptFrom.y+3);
	ptTo_upperLeft = CPoint(ptTo.x-3, ptTo.y-3);
	ptTo_lowerRight = CPoint(ptTo.x+3, ptTo.y+3);

	CPen pen (PS_SOLID, 3, RGB(0,0,0));
    CPen* pOldPen = pDC->SelectObject (&pen);
	pDC->SelectObject (&pen);

	pDC->Rectangle(ptFrom_upperLeft.x, ptFrom_upperLeft.y, ptFrom_lowerRight.x, ptFrom_lowerRight.y);
	pDC->Rectangle(ptTo_upperLeft.x, ptTo_upperLeft.y, ptTo_lowerRight.x, ptTo_lowerRight.y);

	pDC->SelectObject (pOldPen);
}