// RoadCollection.cpp: implementation of the RoadCollection class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Map Studio MAX R1.h"
#include "RoadCollection.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

IMPLEMENT_SERIAL (RoadCollection, CObject, 1)

RoadCollection::RoadCollection()
{

}

RoadCollection::~RoadCollection()
{

}


CRoad* RoadCollection::AddRoad (CPoint ptFrom, CPoint ptTo, UINT nWidth, UINT lines_distance, COLORREF crColor)
{
    CRoad* pRoad;
    try 
	{
        pRoad = new CRoad (ptFrom, ptTo, nWidth, lines_distance, crColor);
        m_roadArray.Add (pRoad);
        //SetModifiedFlag();
    }
    catch (CMemoryException* error)
	{
        if (pRoad != NULL) 
		{
			delete pRoad;
            pRoad = NULL;
        }
        AfxMessageBox ("Out of memory", MB_ICONSTOP | MB_OK);
        error->Delete ();
    }
    return pRoad;
}

void RoadCollection::DeleteRoad (int index)
{
	m_roadArray.RemoveAt(index);
}

void RoadCollection::DeleteRoadContents ()
{
    int road_size = m_roadArray.GetSize ();

    if (road_size) 
	{
        for (int i=0; i<road_size; i++)
            delete m_roadArray[i];
        m_roadArray.RemoveAll ();
    }
}


CRoad* RoadCollection::GetRoad (int nIndex)
{
    return (CRoad*) m_roadArray[nIndex];
}


int RoadCollection::GetRoadCount ()
{
    return m_roadArray.GetSize ();
}


void RoadCollection::Serialize (CArchive& ar)
{
    CObject::Serialize (ar);
	m_roadArray.Serialize (ar);
}


CObArray* RoadCollection::GetRoadCollection()
{
	return (CObArray*) &m_roadArray;
}

