// RoadMode.cpp: implementation of the CRoadMode class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Map Studio MAX R1.h"
#include "RoadMode.h"
#include "RoadView.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

IMPLEMENT_DYNAMIC(CRoadMode, CMode)

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CRoadMode::CRoadMode(CMapDoc* doc)
:CMode(doc)
{
	hit = false;
	index =0;
}

CRoadMode::~CRoadMode()
{

}

CRoadMode::OnLButtonDown(UINT nFlags, CPoint point, CDC* pDC)
{
	for (int n=0; ( (n<(_doc->road_collection->GetRoadCount())) && !hit); n++)
		if (_doc->road_collection->GetRoad(n)->HitTest(point))
		{
			CRoadView temp_road_view;
			road_selected = _doc->road_collection->GetRoad(n);
			temp_road_view.SelectedRoad(pDC, road_selected->GetStartingPoint(),
										road_selected->GetEndPoint());
			index = n;
			hit = true;
		}
}

CRoadMode::OnLButtonUp(UINT nFlags, CPoint point, CDC* pDC)
{
	CPoint m_ptFrom = GetView()->Getm_ptFrom();
	CRoad* pRoad = _doc->road_collection->AddRoad(m_ptFrom, point, 2, 15, RGB(102,51,0));
	if (pRoad != NULL) 
	{
		CRoadView* temp_road_view = new CRoadView(pRoad);						
		temp_road_view->Draw(pDC);
		_doc->UpdateAllViews(GetView(), 0, pRoad);
		_doc->widgets_sequence.Add("road");
		_doc->SetModifiedFlag(TRUE);
	}
}

CRoadMode::OnMouseMove_Move(UINT nFlags, CPoint point, CDC* pDC)
{
	CSize diff; //amount moved
	
	diff.cx = point.x - road_selected->GetStartingPoint().x;
	diff.cy = point.y - road_selected->GetStartingPoint().y;

	road_selected->SetStartingPoint(CPoint(point.x, point.y));
	road_selected->SetEndPoint( CPoint(road_selected->GetEndPoint().x + diff.cx, 
								road_selected->GetEndPoint().y + diff.cy));
}

CRoadMode::OnMouseMove_Draw(UINT nFlags, CPoint point, CDC* pDC)
{
	CRoadView temp_road_view;
	
	CPoint m_ptFrom = GetView()->Getm_ptFrom();
	CPoint m_ptTo = GetView()->Getm_ptTo();
	
	temp_road_view.InvertRoad(pDC, m_ptFrom, m_ptTo, 15);
	temp_road_view.InvertRoad(pDC, m_ptFrom, point, 15);
}

CRoadMode::OnMouseMove_Resize(UINT nFlags, CPoint point, CDC* pDC)
{
	CSize diff; //amount moved
	
	diff.cx = point.x - road_selected->GetStartingPoint().x;
	diff.cy = point.y - road_selected->GetStartingPoint().y;

	road_selected->SetEndPoint( CPoint(point.x, point.y));
}

void CRoadMode::delete_selected()
{
	_doc->road_collection->DeleteRoad(index);
}

CRoadMode::DoDialog()
{

}

bool CRoadMode::IsHit()
{
	return hit;
}

CMapView* CRoadMode::GetView() 
{
	POSITION pos = _doc->GetFirstViewPosition();
	return (CMapView*) _doc->GetNextView(pos);
}
