// RoadView.cpp: implementation of the CRoadView class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Map Studio MAX R1.h"
#include "RoadView.h"
#include <math.h>
#include <stdlib.h>

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif


//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CRoadView::CRoadView()
{

}

CRoadView::CRoadView(CRoad *road)
{
    m_StartingPoint = road->GetStartingPoint();
    m_EndPoint = road->GetEndPoint();
    m_LineWidth = road->GetLineWidth();
    m_LineColor = road->GetRoadColor();
	distance_porpotion = road->GetRoadWidth();
}

CRoadView::~CRoadView()
{

}


void CRoadView::Draw (CDC* pDC)
{
    CPen pen (PS_SOLID, m_LineWidth, m_LineColor);
    CPen* pOldPen = pDC->SelectObject (&pen);
	pDC->SelectObject (&pen);

	// Two straight lines is the basic to construct a basic road. Since the 
	// mouse only supply two sets of cordinates, which is the starting point
	// and the ending point, to construct a straight line. Another straight
	// line, however, is required to built the road. Thus, trigronometri is 
	// is being implement to calculate the mirrored line. It should meet two
	// following requirements : 1, There should be a constant disctance between 
	// two lines  2, Both the starting and ending cordinates of both line should
	// be in 90 degree porpotion to each other.



	// define pi
    double pi = 3.1415926535;

	// define distance between line

	// define the horizontal and vertical distance for the line draw
	double distance_x = m_EndPoint.x-m_StartingPoint.x;
	double distance_y = m_EndPoint.y-m_StartingPoint.y;

	// avoid devide by zero
	if (distance_x == 0)
	{	
		x = m_StartingPoint.x + distance_porpotion;
		y = m_StartingPoint.y;
		
		x1 = x + (int)distance_x;
		y1 = y + (int)distance_y;
		
		pDC->MoveTo(m_StartingPoint);
		pDC->LineTo(m_EndPoint);
		
		pDC->MoveTo(CPoint(x,y));
	    pDC->LineTo(CPoint(x1,y1));

		return;
	}

	// to Disable visual artifact
	if (distance_y == 0)
	{	
		x = m_StartingPoint.x ;
		y = m_StartingPoint.y - distance_porpotion;
		
		x1 = x + (int)distance_x;
		y1 = y + (int)distance_y;
		
		pDC->MoveTo(m_StartingPoint);
		pDC->LineTo(m_EndPoint);
		
		pDC->MoveTo(CPoint(x,y));
	    pDC->LineTo(CPoint(x1,y1));

		return;
	}

	double gradiant =  distance_y / distance_x ;

	// To make sure gradiant to always have a possitive value
	if ( gradiant < 0)
		gradiant = gradiant * -1;

	// define the angle for the triangle ,reponsible for transforming the mirrored line
	double alpha = (double) ((pi/2) - (atan(gradiant)));

	// calculate the number of horizontal and vertical pixels to transform the mirrored
	// line into a possition porpotion to the original line
	int horizontal = (int) (distance_porpotion * (sin (alpha)));
	int diagonal = (int) (distance_porpotion * (cos (alpha)));

	// Define the transformation for four types of line direction
	// North-east line 
	if ((distance_x > 0) && (distance_y < 0))
	{
		y = m_StartingPoint.y - horizontal;
		x = m_StartingPoint.x - diagonal;
	}

	// South-west line
	if ((distance_x < 0) && (distance_y > 0))
	{
		y = m_StartingPoint.y + horizontal;
		x = m_StartingPoint.x + diagonal;
	}

	// North-west line
	if ((distance_x < 0) && (distance_y < 0))
	{
		y = m_StartingPoint.y + horizontal;
		x = m_StartingPoint.x - diagonal;
	}

	// South-east line
	if ((distance_x > 0) && (distance_y > 0))
	{
		y = m_StartingPoint.y - horizontal;
		x = m_StartingPoint.x + diagonal;
	}

	// define the other end cordinate for the mirrored line
	x1 = x + (int)distance_x;
	y1 = y + (int)distance_y;

	// draw the original line
	pDC->MoveTo(m_StartingPoint);
    pDC->LineTo(m_EndPoint);
	
	// draw the mirrored line
	pDC->MoveTo(CPoint(x,y));
    pDC->LineTo(CPoint(x1,y1));
	pDC->SelectObject (pOldPen);
}


void CRoadView::InvertRoad (CDC* pDC, CPoint ptFrom, CPoint ptTo, UINT lines_distance)
{
	int nOldMode = pDC->SetROP2 (R2_NOTXORPEN);

	m_StartingPoint = ptFrom;
    m_EndPoint = ptTo;
	distance_porpotion = lines_distance;
    // Same implementation as the one seen in Draw method. Codes are being
	// repeated due to the difficulties encountered when drawing a dotter line
	// bridge in seperate private function.
	// define pi

    double pi = 3.1415926535;

	// define distance between line

	// define the horizontal and vertical distance for the line draw
	double distance_x = m_EndPoint.x-m_StartingPoint.x;
	double distance_y = m_EndPoint.y-m_StartingPoint.y;

	// avoid devide by zero
	if (distance_x == 0)
	{	
		x = m_StartingPoint.x + distance_porpotion;
		y = m_StartingPoint.y;
		
		x1 = x + (int)distance_x;
		y1 = y + (int)distance_y;
		
		pDC->MoveTo(m_StartingPoint);
		pDC->LineTo(m_EndPoint);
		
		pDC->MoveTo(CPoint(x,y));
	    pDC->LineTo(CPoint(x1,y1));

		return;
	}

	// to Disable visual artifact
	if (distance_y == 0)
	{	
		x = m_StartingPoint.x ;
		y = m_StartingPoint.y - distance_porpotion;
		
		x1 = x + (int)distance_x;
		y1 = y + (int)distance_y;
		
		pDC->MoveTo(m_StartingPoint);
		pDC->LineTo(m_EndPoint);
		
		pDC->MoveTo(CPoint(x,y));
	    pDC->LineTo(CPoint(x1,y1));

		return;
	}



	double gradiant =  distance_y / distance_x ;
	
	// To make sure gradiant to always have a possitive value
	if ( gradiant < 0)
		gradiant = gradiant * -1;

	// define the angle for the triangle ,reponsible for transforming the mirrored line
	double alpha = (double) ((pi/2) - (atan(gradiant)));

	// calculate the number of horizontal and vertical pixels to transform the mirrored
	// line into a possition porpotion to the original line
	int horizontal = (int) (distance_porpotion * (sin (alpha)));
	int diagonal = (int) (distance_porpotion * (cos (alpha)));

	// Define the transformation for four types of line direction
	// North-east line 
	if ((distance_x > 0) && (distance_y < 0))
	{
		y = m_StartingPoint.y - horizontal;
		x = m_StartingPoint.x - diagonal;
	}

	// South-west line
	if ((distance_x < 0) && (distance_y > 0))
	{
		y = m_StartingPoint.y + horizontal;
		x = m_StartingPoint.x + diagonal;
	}

	// North-west line
	if ((distance_x < 0) && (distance_y < 0))
	{
		y = m_StartingPoint.y + horizontal;
		x = m_StartingPoint.x - diagonal;
	}

	// South-east line
	if ((distance_x > 0) && (distance_y > 0))
	{
		y = m_StartingPoint.y - horizontal;
		x = m_StartingPoint.x + diagonal;
	}

	// define the other end cordinate for the mirrored line
	int x_1 = x + (int)distance_x;
	int y_1 = y + (int)distance_y;

	// draw the original line
	pDC->MoveTo(m_StartingPoint);
    pDC->LineTo(m_EndPoint);
	
	// draw the mirrored line
	pDC->MoveTo(CPoint(x,y));
    pDC->LineTo(CPoint(x_1,y_1));

	m_StartingPoint = 0;
    m_EndPoint = 0;    
	
	pDC->SetROP2(nOldMode);
}

void CRoadView::SelectedRoad (CDC* pDC, CPoint ptFrom, CPoint ptTo)
{
	CPoint ptFrom_upperLeft, ptFrom_lowerRight, ptTo_upperLeft, ptTo_lowerRight;
	
	ptFrom_upperLeft = CPoint(ptFrom.x-3, ptFrom.y-3);
	ptFrom_lowerRight = CPoint(ptFrom.x+3, ptFrom.y+3);
	ptTo_upperLeft = CPoint(ptTo.x-3, ptTo.y-3);
	ptTo_lowerRight = CPoint(ptTo.x+3, ptTo.y+3);

	CPen pen (PS_SOLID, 3, RGB(0,0,0));
    CPen* pOldPen = pDC->SelectObject (&pen);
	pDC->SelectObject (&pen);

	pDC->Rectangle(ptFrom_upperLeft.x, ptFrom_upperLeft.y, ptFrom_lowerRight.x, ptFrom_lowerRight.y);
	pDC->Rectangle(ptTo_upperLeft.x, ptTo_upperLeft.y, ptTo_lowerRight.x, ptTo_lowerRight.y);

	pDC->SelectObject (pOldPen);
}

