// Text.cpp: implementation of the CText class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Map Studio MAX R1.h"
#include "Text.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////
IMPLEMENT_SERIAL (CText, CObject, 1)

CText::CText (CPoint ptFrom, CPoint ptTo, COLORREF crColor, CString object_name)
{
    m_StartingPoint = ptFrom;
	m_LineColor = crColor;
	m_ObjectName = object_name;
	int string_length = m_ObjectName.GetLength();
	string_length = string_length * 6;
    m_EndPoint = CPoint(ptFrom.x + string_length, ptFrom.y+16);
}

void CText::Serialize (CArchive& ar)
{
    CObject::Serialize (ar);

    if (ar.IsStoring ())
        ar << m_StartingPoint << m_EndPoint << m_LineColor << m_ObjectName;
    else
        ar >> m_StartingPoint >> m_EndPoint >> m_LineColor >> m_ObjectName;
}

// Get methods
CPoint CText::GetStartingPoint()
{
	return m_StartingPoint;
}

CPoint CText::GetEndPoint()
{
	return m_EndPoint;
}

COLORREF CText::GetTextColor()
{
	return m_LineColor;
}

CString CText::GetText()
{
	return m_ObjectName;
}

// Set methods
void CText::SetStartingPoint(CPoint start_point)
{
	m_StartingPoint = start_point;
}

void CText::SetEndPoint(CPoint end_point)
{
	m_EndPoint = end_point;
}

void CText::SetTextColor(COLORREF line_color)
{
	m_LineColor = line_color;
}

void CText::SetText(CString _object_name)
{
	m_ObjectName = _object_name;
}

// mouse click test
bool CText::HitTest(CPoint point)
{
    // check handles
    CRect R;

    R = CRect(m_StartingPoint, m_EndPoint);
    R.NormalizeRect();

    R.InflateRect( 5, 5 );
    
    if (R.PtInRect(point))
		return true;

	return false;
}

