// TextCollection.cpp: implementation of the TextCollection class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Map Studio MAX R1.h"
#include "TextCollection.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

IMPLEMENT_SERIAL (TextCollection, CObject, 1)

TextCollection::TextCollection()
{

}

TextCollection::~TextCollection()
{

}


CText* TextCollection::AddText (CPoint ptFrom, CPoint ptTo, COLORREF crColor, CString object_name)
{
    CText* pText;
    try
	{
        pText = new CText (ptFrom, ptTo, crColor, object_name);
        m_textArray.Add(pText);
        //SetModifiedFlag();
    }
    catch (CMemoryException* error) 
	{
        if (pText != NULL) 
		{
            delete pText;
            pText = NULL;
        }
        AfxMessageBox ("Out of memory", MB_ICONSTOP | MB_OK);
        error->Delete ();
    }
    return pText;
}

void TextCollection::DeleteText (int index)
{
	m_textArray.RemoveAt(index);
}

void TextCollection::DeleteTextContents ()
{
    int text_size = m_textArray.GetSize ();

    if (text_size) 
	{
        for (int i=0; i<text_size; i++)
            delete m_textArray[i];
        m_textArray.RemoveAll ();
    }
}


CText* TextCollection::GetText (int nIndex)
{
    return (CText*) m_textArray[nIndex];
}


int TextCollection::GetTextCount ()
{
    return m_textArray.GetSize ();
}

void TextCollection::Serialize (CArchive& ar)
{
    CObject::Serialize(ar);
	m_textArray.Serialize (ar);
}

CObArray* TextCollection::GetTextCollection()
{
	return (CObArray*) &m_textArray;
}
