// TextMode.cpp: implementation of the CTextMode class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Map Studio MAX R1.h"
#include "TextMode.h"
#include "TextView.h"
#include "TextInputDlg.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

IMPLEMENT_DYNAMIC(CTextMode, CMode)

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CTextMode::CTextMode(CMapDoc* doc)
:CMode(doc)
{
	hit = false;
	index =0;
}

CTextMode::~CTextMode()
{

}

CTextMode::OnLButtonDown(UINT nFlags, CPoint point, CDC* pDC)
{
	for (int n=0; ( (n<(_doc->text_collection->GetTextCount())) && !hit); n++)
		if (_doc->text_collection->GetText(n)->HitTest(point))
		{
			CTextView temp_text_view;
			text_selected = _doc->text_collection->GetText(n);
			temp_text_view.SelectedText(pDC, text_selected->GetStartingPoint(),
										text_selected->GetEndPoint());
			index = n;
			hit = true;
		}
}

CTextMode::OnLButtonUp(UINT nFlags, CPoint point, CDC* pDC)
{
	CPoint m_ptFrom = GetView()->Getm_ptFrom();
	CText* pText = _doc->text_collection->AddText(m_ptFrom, point, RGB(0,0,140), _dlg_text);
	if (pText != NULL) 
	{
		CTextView* temp_text_view = new CTextView(pText);						
		temp_text_view->Draw(pDC);
		_doc->UpdateAllViews(GetView(), 0, pText);
		_doc->widgets_sequence.Add("text");
		_doc->SetModifiedFlag(TRUE);
	}
}

CTextMode::OnMouseMove_Move(UINT nFlags, CPoint point, CDC* pDC)
{
	CSize diff; //amount moved
			
	diff.cx = point.x - text_selected->GetStartingPoint().x;
	diff.cy = point.y - text_selected->GetStartingPoint().y;
	
	text_selected->SetStartingPoint(CPoint(point.x, point.y));
	text_selected->SetEndPoint( CPoint(text_selected->GetEndPoint().x + diff.cx, 
								text_selected->GetEndPoint().y + diff.cy));
}

CTextMode::OnMouseMove_Draw(UINT nFlags, CPoint point, CDC* pDC)
{

}

CTextMode::OnMouseMove_Resize(UINT nFlags, CPoint point, CDC* pDC)
{
	AfxMessageBox("Text does not support resize!");
}

void CTextMode::delete_selected()
{
	_doc->text_collection->DeleteText(index);
}

CTextMode::DoDialog()
{
	CTextInputDlg InputDlg;
	
	if ((InputDlg.DoModal()) == IDOK)
		_dlg_text = InputDlg.m_text_input;
}

bool CTextMode::IsHit()
{
	return hit;
}

CMapView* CTextMode::GetView() 
{
	POSITION pos = _doc->GetFirstViewPosition();
	return (CMapView*) _doc->GetNextView(pos);
}


