// ricleCollection.cpp: implementation of the CricleCollection class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Map Studio MAX R1.h"
#include "ricleCollection.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

IMPLEMENT_SERIAL (CircleCollection, CObject, 1)

CircleCollection::CircleCollection()
{

}

CircleCollection::~CircleCollection()
{

}


CCircle* CircleCollection::AddCircle (CPoint ptFrom, CPoint ptTo, UINT nWidth, COLORREF crColor)
{
    CCircle* pCircle;
    try
	{
        pCircle = new CCircle (ptFrom, ptTo, nWidth, crColor);
        m_circleArray.Add(pCircle);
    }
    catch (CMemoryException* error) 
	{
        if (pCircle != NULL) 
		{
            delete pCircle;
            pCircle = NULL;
        }
        AfxMessageBox ("Out of memory", MB_ICONSTOP | MB_OK);
        error->Delete ();
    }
    return pCircle;
}

void CircleCollection::DeleteCircle (int index)
{
	m_circleArray.RemoveAt(index);
}

void CircleCollection::DeleteCircleContents ()
{
    int circle_size = m_circleArray.GetSize ();

    if (circle_size) 
	{
        for (int i=0; i<circle_size; i++)
            delete m_circleArray[i];
        m_circleArray.RemoveAll ();
    }
}


CCircle* CircleCollection::GetCircle (int nIndex)
{
    return (CCircle*) m_circleArray[nIndex];
}


int CircleCollection::GetCircleCount ()
{
    return m_circleArray.GetSize ();
}

void CircleCollection::Serialize (CArchive& ar)
{
    CObject::Serialize(ar);
	m_circleArray.Serialize (ar);
}

CObArray* CircleCollection::GetCircleCollection()
{
	return (CObArray*) &m_circleArray;
}
